
/**
 * Demonstriert das Singleton-Pattern
 * 
 * @author      Florian
 * @version     Kapitel 10
 */
public class Einwohnermeldeamt
{
    /** 
     * Hlt eine Referenz auf das einzige Objekt dieser Klasse
     */
    private static Einwohnermeldeamt instance = new Einwohnermeldeamt(); 

    /**
     * Privater Konstruktor - verhindert die Objekterzeugung auerhalb der Klasse 
     */
    private Einwohnermeldeamt() { }

    /**
     * Gibt die Instanz der Klasse zurck
     * @return Die Instanz der Klasse 
     */
    public static Einwohnermeldeamt getInstance()
    { 
        return instance;
    }
}