
import java.awt.Color;
import javax.swing.*; 
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

public class MyFrame extends JFrame
{   
    private JMenuBar mnHauptmenue = new JMenuBar();
    private JRadioButtonMenuItem rot = new JRadioButtonMenuItem("rot"); 
    private JRadioButtonMenuItem blau = new JRadioButtonMenuItem("blau");  
    private JRadioButtonMenuItem gelb = new JRadioButtonMenuItem("gelb");

    MyFrame()
    {
        // Die Gre des Fensters in Pixel
        this.setSize(300, 250); 

        // Programm beenden, wenn Fenster geschlossen wird
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        // einen Menpunkt generieren
        JMenu mnDatei = new JMenu("Datei");
        mnDatei.setMnemonic('D');

        // Menpunkt dem JMenu hinzufgen
        mnHauptmenue.add(mnDatei);

        // Menpunkt Hintergrundfarbe
        JMenu mnHintergrundfarbe = new JMenu("Hintergrundfarbe");

        // Eventlistener anlegen und bei den Radiobuttons einhngen
        ItemListener itemListener = new MyItemListener();        
        gelb.addItemListener(itemListener);
        blau.addItemListener(itemListener);
        rot.addItemListener(itemListener);

        rot.setSelected(true);
        mnHintergrundfarbe.add(rot);
        mnHintergrundfarbe.add(blau);
        mnHintergrundfarbe.add(gelb);

        // Radiobuttons zu einer Gruppe zusammenfassen
        ButtonGroup gruppe = new ButtonGroup();
        gruppe.add(rot);
        gruppe.add(blau);
        gruppe.add(gelb);

        mnDatei.add(mnHintergrundfarbe);

        // das Hauptmen hinzufgen
        this.setJMenuBar(mnHauptmenue);

        // Fenster anzeigen
        this.setVisible(true);
    }

    private void aendernFarbe(Color color)
    { 
        this.getContentPane().setBackground(color);
    }

    private class MyItemListener implements ItemListener
    { 
        @Override
        public void itemStateChanged(ItemEvent e)
        { 
            JRadioButtonMenuItem temp = (JRadioButtonMenuItem) e.getItem(); 

            if(temp == rot)
            // hier alternativ auch mglich: 
            // if(rot.isSelected())
            { 
                aendernFarbe(Color.RED);
            }
            else
            {
                //alternativ auch mglich: 
                // if(temp == blau)
                if (blau.isSelected())
                {
                    aendernFarbe(Color.BLUE);
                }
                else
                {
                    aendernFarbe(Color.yellow);
                }
            }
        }
    }

}