/**
 * Demonstriert die Verwendung der Klasse DemoJEditorPane
 * 
 * @author      Florian 
 * @version     Kapitel 12
 */
import java.io.IOException;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.text.html.HTMLEditorKit;

public class DemoJEditorPane extends JFrame
{    
    // GUI
    private JFrame frmMain;
    
    // Variable fr JTextField
    private JEditorPane edpText;
    
    public static void main(String[] args)
    {
        new DemoJEditorPane();
    }
    
    public DemoJEditorPane()
    {
        // eine Oberflche wie im vorigen Beispiel erstellen
        frmMain = new JFrame();
        
        // Titel fr das Fenster
        frmMain.setTitle("Demo JEditorPane");
        
        // Grundlage fr die Komponenten
        JPanel pnlOberflaeche = new JPanel();
         
        // Instanz der Klasse JTextField
        edpText = new JEditorPane();
        
        // Text darf nicht editiert werden
        edpText.setEditable(false);
        
        // EditorKit installieren
        HTMLEditorKit editorKit = new HTMLEditorKit();
        edpText.setEditorKit(editorKit);
        
        try
        {
            edpText.setPage("http://www.BlueJ-Buch.de");
        }
        catch(IOException ex)
        {
            System.out.println(ex);
        }
        
    
        // ScrollPane fr die TextArea
        JScrollPane scrText = new JScrollPane(edpText);
        
        // Panel in das Fenster einfgen
        frmMain.getContentPane().add(scrText);
        
        // optimale Gre 
        frmMain.setSize(400, 200);
        
        // Oberflche anzeigen
        frmMain.setVisible(true);
    }
}