
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;

/**
 * Demonstriert die Verwendung der Klasse DemoJPasswordField
 * 
 * @author      Florian 
 * @version     Kapitel 12
 */

public class DemoJPasswordField extends JFrame implements ActionListener, CaretListener
{    
    // GUI
    private JFrame frmMain;
    
    // Variable fr JTextField
    private JPasswordField edtPasswort;
    
    public static void main(String[] args)
    {
        new DemoJPasswordField();
    }
    
    public DemoJPasswordField()
    {
        // eine Oberflche wie im vorigen Beispiel erstellen
        frmMain = new JFrame();
        
        // Titel fr das Fenster
        frmMain.setTitle("Demo JTextField");
        
        // Grundlage fr die Komponenten
        JPanel pnlOberflaeche = new JPanel();
         
        // Instanz der Klasse JTextField
        edtPasswort = new JPasswordField("Ich war eine Coladose", 20);
        
        edtPasswort.setEchoChar('_');
        
        // Selektion abfragen
        int anfang = edtPasswort.getSelectionStart();
        int ende = edtPasswort.getSelectionEnd();
        
        // Lnge der Selektion berechnen
        int laenge = ende - anfang;
        System.out.println("Die Lnge der Markierung: " + laenge);
        
        // Listener registrieren: 
        edtPasswort.addActionListener(this);
        edtPasswort.addCaretListener(this);
        
        // Textfeld der Oberflche hinzufgen
        pnlOberflaeche.add(edtPasswort);
        
        // Panel in das Fenster einfgen
        frmMain.getContentPane().add(pnlOberflaeche);
        
        // optimale Gre 
        frmMain.setSize(300, 200);
        
        // Oberflche anzeigen
        frmMain.setVisible(true);
    }
    
    public void actionPerformed(ActionEvent ev)
    {
        // deprecated: String tmp = edtPasswort.getText();
        char[] passwort = edtPasswort.getPassword();
        String temp = String.valueOf(passwort);
        frmMain.setTitle(temp);
    }
    
    public void caretUpdate(CaretEvent ev)
    {
        int position = edtPasswort.getCaretPosition();        
        frmMain.setTitle("Position: " + position);
    }
}