package BorderLayout;
 
/**
 * Demonstriert die praktische Anwendung des BorderLayout
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */
import java.awt.BorderLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;

public class Demo_2
{
    public static void main(String[] args)
    {
        // Rahmen erzeugen 
        JFrame fenster = new JFrame();
        
        // Titel erzeugen
        fenster.setTitle("Demo BorderLayout");
        
        // Container fr die Komponenten anlegen 
        JPanel oberflaeche = new JPanel();        
        
        // LayoutManager erstellen
        BorderLayout layout = new BorderLayout();  
        
        // LayoutManger dem Container zuweisen
        oberflaeche.setLayout(layout);
        
        // die Panels in die jeweiligen Bereichen einsortieren
        oberflaeche.add(new PanelNorth(), BorderLayout.NORTH);
        oberflaeche.add(new PanelSouth(), BorderLayout.SOUTH);
        oberflaeche.add(new PanelEast(), BorderLayout.EAST);
        oberflaeche.add(new PanelWest(), BorderLayout.WEST);
        oberflaeche.add(new JTextArea(), BorderLayout.CENTER);
        
        // Container auf das Fenster packen 
        fenster.getContentPane().add(oberflaeche); 
        
        // berschrift
        JLabel lblUeberschrift = new JLabel("Geschachtelte Layoutmanager", SwingConstants.CENTER);
        fenster.getContentPane().add(lblUeberschrift, BorderLayout.NORTH);
        
        // Optimale Ausrichtung anfordern
        fenster.pack();
        
        // Was passieren soll, wenn ...
        fenster.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        // Fenster anzeigen
        fenster.setVisible(true);
        
    }
}
