package GridBagLayout;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
 
/**
 * Demonstriert die Verwendung des GridBagLayout
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */

public class DemoGridBagLayout_1
{
    public static void main(String[] args)
    {
        // Fenster erzeugen
        JFrame frmMain = new JFrame();
        
        // Die ContentPane beziehen
        Container ctpOberflaeche = frmMain.getContentPane();
        
        // LayoutManager
        GridBagLayout layout = new GridBagLayout();
        ctpOberflaeche.setLayout(layout);
        
        // Ein Objekt fr die Constraints anlegen
        GridBagConstraints constraints = new GridBagConstraints();
        
        // Einen Button an der linken oberen Ecke beginnen lassen
        constraints.gridx = 0;
        constraints.gridy = 0;
        
        // Komponente anlegen
        JButton btnKlick = new JButton("Mein erster GridBag-Button");
        
        // Komponente und Constraints an Layout bergeben
        layout.setConstraints(btnKlick, constraints);
        
        // Komponente auf Container packen
        ctpOberflaeche.add(btnKlick);
        
        // optimale Gre
        frmMain.pack();
        
        // Was beim Schlieen passieren soll
        frmMain.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        // Fenster anzeigen
        frmMain.setVisible(true);
        
    }
}
