package GridBagLayout;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JButton;
import javax.swing.JFrame;

/**
 * Demonstriert die Verwendung des GridBagLayout
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */

public class DemoGridBagLayout_4
{
    public static void main(String[] args)
    {
        // Fenster erzeugen
        JFrame frmMain = new JFrame();
        
        // Die ContentPane beziehen
        Container ctpOberflaeche = frmMain.getContentPane();
        
        // LayoutManager
        GridBagLayout layout = new GridBagLayout();
        ctpOberflaeche.setLayout(layout);
        
        // Ein Objekt fr die Constraints anlegen
        GridBagConstraints constraints = new GridBagConstraints();
        
        // Der erste Button
        
        // Einen Button an der linken oberen Ecke beginnen lassen
        constraints.gridx = 0;
        constraints.gridy = 0;
        
        // Komponente anlegen
        JButton btnKlick_1 = new JButton("Position 0 / 0");
        
        // Komponente und Constraints an Layout bergeben
        layout.setConstraints(btnKlick_1, constraints); 
        
        // ein zweiter Button
        
        // Einen Button an der Position: 2. Spalte, 1. Reihe beginnen lassen
        constraints.gridx = 1;
        constraints.gridy = 0;
        
        // Komponente anlegen
        JButton btnKlick_2 = new JButton("Position 1 / 0");
        
        // Komponente und Constraints an Layout bergeben
        layout.setConstraints(btnKlick_2, constraints); 
        
        // ein dritter Button
        
        // Einen Button an der Position erste Spalte, zweite Zeile beginnen lassen
        constraints.gridx = 0;
        constraints.gridy = 1;
        
        // Komponenten darf zwei Zellen gro sein
        constraints.gridwidth = 2; 
        // constraints.gridwidth = GridBagConstraints.REMAINDER; 
        
        // Ausdehnung der Komponenten festlegen
        constraints.fill = GridBagConstraints.HORIZONTAL;
        
        // Komponente anlegen
        JButton btnKlick_3 = new JButton("Position 0 / 1");
        
        // Komponente und Constraints an Layout bergeben
        layout.setConstraints(btnKlick_3, constraints); 
                
        // ein vierter Button
        
        // Einen Button an der Position dritte Spalte, dritte Zeile beginnen lassen
        constraints.gridx = 2;
        constraints.gridy = 2;
        
        // alten Wert zurcksetzen
        constraints.gridwidth = 1;
        constraints.fill = GridBagConstraints.NONE;
        
        // Komponente anlegen
        JButton btnKlick_4 = new JButton("2 / 2");
        
        // Komponente und Constraints an Layout bergeben
        layout.setConstraints(btnKlick_4, constraints); 
        
        // ein fnfter Button
        
        // Einen Button an der Position dritte Spalte, dritte Zeile beginnen lassen
        constraints.gridx = GridBagConstraints.RELATIVE;
        constraints.gridy = 2;
        
        // Komponenten darf zwei Zellen gro sein
        constraints.gridheight = 2;
        
        // in welche Richtung die Komponente sich ausdehnen darf
        // constraints.fill = GridBagConstraints.HORIZONTAL;
        // constraints.fill = GridBagConstraints.VERTICAL;
        constraints.fill = GridBagConstraints.BOTH;
                
        // Komponente anlegen
        JButton btnKlick_5 = new JButton("RELATIVE");
        
        // Komponente und Constraints an Layout bergeben
        layout.setConstraints(btnKlick_5, constraints); 
        
        // ein sechster Button
        
        // alte Werte zurcksetzen
        constraints.gridheight = 1;
        constraints.fill = GridBagConstraints.NONE;
        
        // Einen Button an der Position dritte Spalte, dritte Zeile beginnen lassen
        constraints.gridx = 2;
        constraints.gridy = GridBagConstraints.RELATIVE;
        
        // Komponente anlegen
        JButton btnKlick_6 = new JButton("RELATIVE");
        
        // Komponente und Constraints an Layout bergeben
        layout.setConstraints(btnKlick_6, constraints); 
                
        // ein siebter Button
        
        // Einen Button an der Position vierte Spalte, zweite Zeile beginnen lassen
        constraints.gridx = 3;
        constraints.gridy = 1;
        
        // Komponente anlegen
        JButton btnKlick_7 = new JButton("3 / 1");
        
        // Komponente und Constraints an Layout bergeben
        layout.setConstraints(btnKlick_7, constraints); 
                
        // Komponenten auf Container packen
        ctpOberflaeche.add(btnKlick_1);
        ctpOberflaeche.add(btnKlick_2);
        ctpOberflaeche.add(btnKlick_3);        
        ctpOberflaeche.add(btnKlick_4); 
        ctpOberflaeche.add(btnKlick_5);
        ctpOberflaeche.add(btnKlick_6);
        ctpOberflaeche.add(btnKlick_7);
        
        // optimale Gre
        frmMain.pack();
        
        // Was beim Schlieen passieren soll
        frmMain.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        // Fenster anzeigen
        frmMain.setVisible(true);
        
    }
}
