package GridLayout;

import java.awt.Container;
import java.awt.GridLayout;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JSlider;
import javax.swing.JTextField;

/**
 * Demonstriert die Verwendung des GridLayout
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */

public class DemoGridLayout
{
    public static void main(String[] args)
    {
        // Fenster erzeugen
        JFrame frmMain = new JFrame();
        
        // Die ContentPane beziehen
        Container ctpOberflaeche = frmMain.getContentPane();
        
        // LayoutManager
        GridLayout layout = new GridLayout(3, 2);
        ctpOberflaeche.setLayout(layout);
        
        // JSlider fr das Alter
        JSlider sldAlter = new JSlider(18, 99);
        sldAlter.setPaintTicks(true);
        sldAlter.setMajorTickSpacing(10);
        sldAlter.setPaintLabels(true);
        
        // Komponenten auf die Oberflche legen
        ctpOberflaeche.add(new JLabel("Bitte geben Sie Ihren Namen ein:"));
        ctpOberflaeche.add(new JTextField("Vor- und Nachname"));
        ctpOberflaeche.add(new JLabel("Wie alt sind Sie?"));
        ctpOberflaeche.add(sldAlter);
        ctpOberflaeche.add(new JLabel("Mchten Sie unseren Newsletter erhalten?"));
        ctpOberflaeche.add(new JCheckBox("Ja, ich will informiert werden", true)); 
        
        // optimale Gre
        frmMain.pack();
        
        // Was beim Schlieen passieren soll
        frmMain.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        // Fenster anzeigen
        frmMain.setVisible(true);
        
    }
}
