package JTable_6a;

/**
 * Startklasse und Controller fr das Programm
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */
import java.awt.event.*;
import javax.swing.table.*;

public class Controller implements ActionListener
{
    private Planetenverwaltung model;
    private GUI view;
    
    public Controller(GUI view, Planetenverwaltung model)
    {
        view.tblInfos.setModel(model);   
        view.btnLoeschen.addActionListener(this);
        this.view = view;
        this.model = model;
        
        // Renderer implementieren
        Planetenverwaltung.MyPlanetRenderer renderer = new Planetenverwaltung.MyPlanetRenderer();
        this.view.tblInfos.setDefaultRenderer(Boolean.class, renderer);
        
        // Sorter implementieren
        TableRowSorter<Planetenverwaltung> sorter = new TableRowSorter<Planetenverwaltung>(model);
        view.tblInfos.setRowSorter(sorter);       
    }
    
    public static void main(String[] args)
    {
        new Controller(new GUI(), new Planetenverwaltung());
    }
    
    public void actionPerformed(ActionEvent ev)
    {
        model.loeschePluto();
        view.btnLoeschen.setEnabled(false);
        model.fireTableDataChanged();
        // wird aus didaktischen Grnden gendert: model.fireTableRowsDeleted(8, 8);
    }
} 
