package JTable_6a;

import java.awt.Color;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;

/**
 * Ist die Datenbasis - das Modell - fr die Tabelle
 * 
 * @author      Florian
 * @version     Kapitel 13
 */

public class Planetenverwaltung extends AbstractTableModel
{
    static class MyPlanetRenderer extends DefaultTableCellRenderer
    {
        @Override
        public void setValue(Object value)
        {
            boolean temp = (Boolean) value;
            if(temp)
            {
                setForeground(Color.GREEN);
                setText("Ja");
            }
            else 
            {
                setForeground(Color.RED);
                setText("Nein");
            };
        }
    } 
    
    /**
     * Die Datenbasis - ein Array, das die neun Planeten speichert
     */
    private Planet[] datenbasis = 
    {
        new Planet("Merkur", 87.99, true), 
        new Planet("Venus", 224.7, true), 
        new Planet("Erde", 365.2, true), 
        new Planet("Mars", 687, true), 
        new Planet("Jupiter", 4332, true), 
        new Planet("Saturn", 10760, true), 
        new Planet("Uranus", 30680, true), 
        new Planet("Neptun", 59900, true), 
        new Planet("Pluto", 90800, true)         
    };
    
    /**
     * Listener fr nderungen an der Datenbasis
     */
    private TableModelListener listener = null;

    /**
     * lscht Pluto aus der Liste der Planeten
     */
    public void loeschePluto()
    { 
        /* wird aus didaktischen Grnden auskommentiert: 
        datenbasis = new Planet[]
        {
            new Planet("Merkur", 87.99, true), 
            new Planet("Venus", 224.7, true), 
            new Planet("Erde", 365.2, true), 
            new Planet("Mars", 687, true), 
            new Planet("Jupiter", 4332, true), 
            new Planet("Saturn", 10760, true), 
            new Planet("Uranus", 30680, true), 
            new Planet("Neptun", 59900, true)    
        }; 
         */
        
        datenbasis[8].setIsPlanet(false);
    }
    
    /**
     * gibt die Klasse einer bestimmten Spalte zurck
     * @param int der Spaltenindex
     * @return Klassenobjekt
     */
    @Override
    public Class<?> getColumnClass(int columnIndex)
    {
        if(columnIndex == 0)
            return String.class;
        else if(columnIndex == 1)
            return Double.class; 
        else  
            return Boolean.class; 
    }
    
    
    /**
     * Gibt die Anzahl der Datenstze - Zeilen - zurck
     * @return int - Anzahl der Zeilen
     */
    @Override
    public int getRowCount()
    { 
        return datenbasis.length;
    }

    /**
     * Gibt die Anzahl der Spalten zurck
     * @return int - Anzahl der Spalten
     */
    @Override
    public int getColumnCount()
    { 
        return 3;
    }

    /**
     * gibt die berschrift einer bestimmten Spalten zurck
     * @param int die gesuchte Spalte
     * @return String - Name der berschrift
     */
    @Override
    public String getColumnName(int columnIndex)
    { 
        switch(columnIndex)
        {
            case 0:     return "Planet"; 
            case 1:     return "Umlaufzeit";
            default:    return "ist ein Planet";            
        }
    }

    /**
     * liefert den Wert einer bestimmten Zelle
     * @param int rowIndex - Zeile der betroffenen Zelle
     * @param int columnIndex - Spalte der betroffenen Zelle 
     * @return Object - Wert innerhalb der Zelle 
     */
    @Override
    public Object getValueAt(int rowIndex, int columnIndex)
    {  
        if (columnIndex == 0)
        {
            return datenbasis[rowIndex].getName();
        }
        else if(columnIndex == 1)
        {
            return datenbasis[rowIndex].getUmlaufzeit();
        }      
        else 
        {
            return datenbasis[rowIndex].isPlanet();
        }
    }
}
