package JTable_7a;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.table.TableColumn;
import javax.swing.table.TableRowSorter;

/**
 * Startklasse und Controller fr das Programm
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */

public class Controller implements ActionListener
{
    private Planetenverwaltung model;
    private GUI view;
    
    public Controller(GUI view, Planetenverwaltung model)
    {
        view.tblInfos.setModel(model);   
        view.btnLoeschen.addActionListener(this);
        this.view = view;
        this.model = model; 
        
        // Sorter implementieren
        view.tblInfos.setRowSorter(new TableRowSorter(model));   
         
        // JComboBox fr die Auswahl der Entdecker
        TableColumn entdeckerSpalte = view.tblInfos.getColumnModel().getColumn(3);
        String[] entdecker = new String[]
        {
            "Aristoteles", 
            "Sophokles", 
            "Isaac Newton", 
            "Keppler", 
            "Giordano Bruno"
        };
        JComboBox cmbEntdecker = new JComboBox(entdecker);
        DefaultCellEditor editor = new DefaultCellEditor(cmbEntdecker);
        entdeckerSpalte.setCellEditor(editor);
    }
     
    public static void main(String[] args)
    {
        new Controller(new GUI(), new Planetenverwaltung());
    }
    
    public void actionPerformed(ActionEvent ev)
    {
        model.loeschePluto();
        view.btnLoeschen.setEnabled(false);
        model.fireTableRowsDeleted(8, 8);
    }
} 
