package JTable_7b;

/**
 * Startklasse und Controller fr das Programm
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */
import java.awt.event.*;
import javax.swing.table.*;
import javax.swing.*;

public class Controller implements ActionListener
{
    private Planetenverwaltung model;
    private GUI view;
    
    public Controller(GUI view, Planetenverwaltung model)
    {
        view.tblInfos.setModel(model);   
        view.btnLoeschen.addActionListener(this);
        this.view = view;
        this.model = model; 
        
        // Sorter implementieren
        view.tblInfos.setRowSorter(new TableRowSorter(model));
        // alternativ: view.tblInfos.setAutoCreateRowSorter(true);
         
        // JComboBox fr die Auswahl der Entdecker
        TableColumn entdeckerSpalte = view.tblInfos.getColumnModel().getColumn(3);
        String[] entdecker = new String[]
        {
            "Aristoteles", 
            "Sophokles", 
            "Isaac Newton", 
            "Keppler", 
            "Giordano Bruno"
        };
        JComboBox cmbEntdecker = new JComboBox(entdecker);
        DefaultCellEditor editor = new DefaultCellEditor(cmbEntdecker);
        entdeckerSpalte.setCellEditor(editor);
         
        // Editor fr das Entdeckungsdatum
        TableColumn datumsSpalte = view.tblInfos.getColumnModel().getColumn(4);  
        datumsSpalte.setCellEditor(new DatumsEditor());
    }
     
    public static void main(String[] args)
    {
        new Controller(new GUI(), new Planetenverwaltung());
    }
    
    public void actionPerformed(ActionEvent ev)
    {
        model.loeschePluto();
        view.btnLoeschen.setEnabled(false);
        model.fireTableDataChanged();
    }
} 
