package JTable_7b;

/**
 * Editor fr die Eingabe eines Tagesdatums in einer Tabellenzeile 
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;
import java.awt.Component;

public class DatumsEditor extends AbstractCellEditor implements TableCellEditor
{
    Date datum; 
    JSpinner spnDatum;
    SpinnerDateModel mdlDatum;

    /**
     * Initialisiert den JSpinner
     */
    public DatumsEditor()
    { 
        mdlDatum = new SpinnerDateModel();
        mdlDatum.setCalendarField(Calendar.DAY_OF_YEAR);
        spnDatum = new JSpinner(mdlDatum);   
        JSpinner.DateEditor edtrDatum = new JSpinner.DateEditor(spnDatum, "EEE, dd. MMM yyyy");
        spnDatum.setEditor(edtrDatum); 
    }
 
    /**
     * berschreibt die Methode von AbstractCellEditor 
     * @return Object Datum
     */
    @Override
    public Object getCellEditorValue() 
    {
        return mdlDatum.getDate();
    }

    /**
     * berschreibt die Methode des Interfaces TableCellEditor
     */
    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) 
    {
        return spnDatum;
    } 
}
