package JTable_8;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableRowSorter;

/**
 * Startklasse und Controller fr das Programm
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */

public class Controller implements ActionListener
{
    private Planetenverwaltung model;
    private GUI view;
    
    public Controller(GUI view, Planetenverwaltung model)
    {
        view.tblInfos.setModel(model);   
        view.btnLoeschen.addActionListener(this);
        this.view = view;
        this.model = model; 
        
        // Sorter implementieren
        view.tblInfos.setRowSorter(new TableRowSorter(model));   
         
        // JComboBox fr die Auswahl der Entdecker
        TableColumn entdeckerSpalte = view.tblInfos.getColumnModel().getColumn(3);
        String[] entdecker = new String[]
        {
            "Aristoteles", 
            "Sophokles", 
            "Isaac Newton", 
            "Keppler", 
            "Giordano Bruno"
        };
        JComboBox cmbEntdecker = new JComboBox(entdecker);
        DefaultCellEditor editor = new DefaultCellEditor(cmbEntdecker);
        entdeckerSpalte.setCellEditor(editor);
         
        // Editor fr das Entdeckungsdatum
        TableColumn datumsSpalte = view.tblInfos.getColumnModel().getColumn(4);  
        datumsSpalte.setCellEditor(new DatumsEditor());
        
        // Das ColumnModel abfragen
        TableColumnModel spaltenModell = view.tblInfos.getColumnModel();
        // System.out.println(spalten.getClass()); // Gibt die Klasse des Objektes aus
        spaltenModell.setColumnSelectionAllowed(false);
        
        // Eine Spalte bearbeiten - hier die erste 
        TableColumn eineSpalte = spaltenModell.getColumn(0);
        eineSpalte.setResizable(false);
        
        // Arbiet mit dem TableHeader 
        JTableHeader kopf = view.tblInfos.getTableHeader();
        // kopf.setReorderingAllowed(false);
        // kopf.setResizingAllowed(false);
        
        // Das SelectionModel beeinflussen
        // view.tblInfos.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        // view.tblInfos.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
        // view.tblInfos.setSelectionMode(ListSelectionModel.SINGLE_SELECTION); 
    }  	 
     
    public static void main(String[] args)
    {
        new Controller(new GUI(), new Planetenverwaltung());
    }
    
    public void actionPerformed(ActionEvent ev)
    {
        model.loeschePluto();
        view.btnLoeschen.setEnabled(false);
        model.fireTableDataChanged();
    }
} 
