package JTable_8;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

/**
 * Erstellt einen Menpunkt, um das LaF zu ndern
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */

public class LaF_Menu extends JMenu
{
    /**
     * Konstruktor fr Objekte der Klasse LaF_Menu
     */
    public LaF_Menu()
    {
        // Aufruf des Konstruktors der Superklasse:
        super("Look and Feel");
        
        // Infos ber installierte LaF abfragen
        UIManager.LookAndFeelInfo[] lafs = UIManager.getInstalledLookAndFeels();
        
        // Jedes Look and Feel anpacken
        for (UIManager.LookAndFeelInfo laf : lafs) 
        {
            // Name des LaF
            String name = laf.getName();
            
            // voll qualifizierter Klassenname des LaF
            final String klassenname = laf.getClassName();
            
            // Menpunkt fr dieses LaF anlegen
            JMenuItem menuePunkt = new JMenuItem(name);
            
            // neuen Menpunkt dem Men hinzufgen
            this.add(menuePunkt);
            
            // als ActionListener eine anonyme Klasse anlegen
            menuePunkt.addActionListener
            (
                new ActionListener() 
                {
                    public void actionPerformed(ActionEvent e) 
                    {
                        try 
                        {
                            UIManager.setLookAndFeel(klassenname);
                        }
                        catch (Exception ex) 
                        {
                            System.out.println(ex);
                        }
                        SwingUtilities.updateComponentTreeUI(getRootPane());
                    }
                }
            );
        }
    }
}
