package JTable_8;

import java.util.Date;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;

/**
 * Ist die Datenbasis - das Modell - fr die Tabelle
 * 
 * @author      Florian
 * @version     Kapitel 13
 */

public class Planetenverwaltung extends AbstractTableModel
{ 
    /**
     * Die Datenbasis - ein Array, das die neun Planeten speichert
     */
    private Planet[] datenbasis = 
    {
        new Planet("Merkur", 87.99, true, ""), 
        new Planet("Venus", 224.7, true, ""), 
        new Planet("Erde", 365.2, true, ""), 
        new Planet("Mars", 687, true, ""), 
        new Planet("Jupiter", 4332, true, ""), 
        new Planet("Saturn", 10760, true, ""), 
        new Planet("Uranus", 30680, true, ""), 
        new Planet("Neptun", 59900, true, ""), 
        new Planet("Pluto", 90800, false, "")         
    };
    
    /**
     * Listener fr nderungen an der Datenbasis
     */
    private TableModelListener listener = null;

    /**
     * lscht Pluto aus der Liste der Planeten
     */
    public void loeschePluto()
    {   
        datenbasis[8].setIsPlanet(true); 
    }
    
    /**
     * gibt die Klasse einer bestimmten Spalte zurck
     * @param int der Spaltenindex
     * @return Klassenobjekt
     */
    @Override
    public Class<?> getColumnClass(int columnIndex)
    {
        if(columnIndex == 0)
            return String.class;
        else if(columnIndex == 1)
            return Double.class; 
        else if(columnIndex == 2)             
            return Boolean.class; 
        else if(columnIndex == 3)
            return String.class; 
        else 
            return Date.class;
    }
    
    
    /**
     * Gibt die Anzahl der Datenstze - Zeilen - zurck
     * @return int - Anzahl der Zeilen
     */
    @Override
    public int getRowCount()
    { 
        return datenbasis.length;
    }

    /**
     * gibt zurck, ob die Zelle editierbar ist
     * @param int Zeile der Zelle 
     * @param int Spalte der Zelle 
     * @return boolean - true wenn editierbar, sonst false
     */
    @Override
    public boolean isCellEditable(int row, int column) 
    {
        if(column == 4 || column == 3 || column == 2 || column == 1)
            return true;
        else 
            return false; 
    } 
    
    /**
     * bernimmt einen genderten Wert aus dem JTable in die Datenbasis
     * @param Object aValue - ein Wert beliebigen Typs 
     * @param int rowIndex - Zeile der betroffenen Zelle
     * @param int columnIndex - Spalte der betroffenen Zelle 
     */
    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex)
    { 
        if(columnIndex == 1)
        {
            double neuerWert = (Double) aValue;
            datenbasis[rowIndex].setUmlaufzeit(neuerWert);
        }
        else if(columnIndex == 2)
        {
            boolean neuerWert = (Boolean) aValue;
            datenbasis[rowIndex].setIsPlanet(neuerWert);
        }
        else if(columnIndex == 3)
        {
            String neuerWert = (String) aValue;
            datenbasis[rowIndex].setEntdecker(neuerWert);
        }
        else 
        {
            Date neuerWert = (Date) aValue;
            datenbasis[rowIndex].setEntdeckung(neuerWert);
        }
    }
    
    /**
     * Gibt die Anzahl der Spalten zurck
     * @return int - Anzahl der Spalten
     */
    @Override
    public int getColumnCount()
    { 
        return 5;
    }

    /**
     * gibt die berschrift einer bestimmten Spalten zurck
     * @param int die gesuchte Spalte
     * @return String - Name der berschrift
     */
    @Override
    public String getColumnName(int columnIndex)
    { 
        switch(columnIndex)
        {
            case 0:     return "Planet"; 
            case 1:     return "Umlaufzeit";
            case 2:     return "ist ein Planet";   
            case 4:     return "Datum der Entdeckung";            
            default:     return "Entdecker";
        }
    }

    /**
     * liefert den Wert einer bestimmten Zelle
     * @param int rowIndex - Zeile der betroffenen Zelle
     * @param int columnIndex - Spalte der betroffenen Zelle 
     * @return Object - Wert innerhalb der Zelle 
     */
    @Override
    public Object getValueAt(int rowIndex, int columnIndex)
    {  
        if (columnIndex == 0)
        {
            return datenbasis[rowIndex].getName();
        }
        else if(columnIndex == 1)
        {
            return datenbasis[rowIndex].getUmlaufzeit();
        }      
        else if(columnIndex == 2)
        {
            return datenbasis[rowIndex].isPlanet();
        }
        else if(columnIndex == 3)
        {
            return datenbasis[rowIndex].getEntdecker();
        }
        else 
        {
            return datenbasis[rowIndex].getEntdeckung();
        }
        
    }
}
