package JTree_1;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTree;
import javax.swing.WindowConstants;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 * Stellt die View der Anwendung 
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */

public class GUI extends JFrame
{
    public final JTree trvHimmelskoerper; 
    
    public GUI()
    {        
        // Eine Wurzel anlegen
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("Himmelskrper");
        
        // Wurzel an JTree bergeben 
        trvHimmelskoerper = new JTree(root);
        
        // weitere Knoten erstellen
        erstelleKnoten(root);
                
        //Baum in eine ScrollPane legen
        JScrollPane scrTree = new JScrollPane(trvHimmelskoerper);
        
        // Splitpane anlegen und die ScrollPane mit dem Baum auf die linke Seite legen
        JSplitPane splTree = new JSplitPane();
        
        // Baum links platzieren
        splTree.setLeftComponent(scrTree);
        
        // Splitpane auf das Fenster legen
        getContentPane().add(splTree);
        
        setTitle("Demo JTree");
        pack();
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setVisible(true);
    }
    
    private void erstelleKnoten(DefaultMutableTreeNode root)
    {
        // Planeten anlegen
        DefaultMutableTreeNode planeten = new DefaultMutableTreeNode("Planeten");        
        root.add(planeten);
        planeten.add(new DefaultMutableTreeNode(new Planet("Merkur")));
        planeten.add(new DefaultMutableTreeNode(new Planet("Venus")));
        planeten.add(new DefaultMutableTreeNode(new Planet("Erde")));
        planeten.add(new DefaultMutableTreeNode(new Planet("Mars")));
        planeten.add(new DefaultMutableTreeNode(new Planet("Jupiter")));
        planeten.add(new DefaultMutableTreeNode(new Planet("Saturn")));
        planeten.add(new DefaultMutableTreeNode(new Planet("Uranus")));
        planeten.add(new DefaultMutableTreeNode(new Planet("Neptun")));
                
        // ein paar Monde anlegen
        DefaultMutableTreeNode monde = new DefaultMutableTreeNode("Monde");        
        root.add(monde);
        monde.add(new DefaultMutableTreeNode(new Mond("Luna", "Erde")));  
        monde.add(new DefaultMutableTreeNode(new Mond("Pan", "Saturn")));  
        monde.add(new DefaultMutableTreeNode(new Mond("Pandora", "Saturn")));  
        monde.add(new DefaultMutableTreeNode(new Mond("Atlas", "Saturn")));  
        monde.add(new DefaultMutableTreeNode(new Mond("Prometheus", "Saturn")));  
        monde.add(new DefaultMutableTreeNode(new Mond("Amalthea", "Jupiter")));  
        monde.add(new DefaultMutableTreeNode(new Mond("Thebe", "Jupiter")));  
        monde.add(new DefaultMutableTreeNode(new Mond("Europa", "Jupiter")));  
    }
}
