package JTree_4.controller;

import JTree_4.model.Planetenverwaltung;
import JTree_4.view.GUI;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.TreePath;

/**
 * Controllerklasse des Projektes
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */

public class Controller implements TreeSelectionListener
{
    /**
     * Model des Projektes
     */
    private Planetenverwaltung model; 
    /**
     * View des Projektes
     */
    private GUI view;
    
    public Controller(Planetenverwaltung model, GUI view) 
    {
        this.model = model;
        this.view = view;
        
        // Model des JTree setzen
        view.trvHimmelskoerper.setModel(model);        
        
        // ActionListener anmelden
        view.trvHimmelskoerper.addTreeSelectionListener(this);
    }
                
    /**
     * auf Auswahl reagieren
     */
    @Override
    public void valueChanged(TreeSelectionEvent ev)
    {
        // alle Selektionen abfragen
        TreePath[] alleSelektionen = view.trvHimmelskoerper.getSelectionPaths();
        for(TreePath auswahl: alleSelektionen)
        {
            System.out.println(auswahl);
        }
    }
}
