package JTree_4.model;

/**
 * Die Klasse Planetenverwaltung ist das Model des Projektes
 * 
 * @author      Florian
 * @version     Kapitel 13
 */
import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

public class Planetenverwaltung implements TreeModel
{
    /**
     * Root-Objekt
     */
    private RootHimmelskoerper root;
    /**
     * finale Variable, die die Beschreibung der Art des Himmelskrpers speichert
     */    
    private final String MONDE = "Monde";
    /**
     * finale Variable, die die Beschreibung der Art des Himmelskrpers speichert
     */        
    private final String PLANETEN = "Planeten";
    
    /**
     * Erzeugt eine Instanz der Wurzel
     */
    public Planetenverwaltung()
    {
        root = new RootHimmelskoerper();
    }

    // Auf die weitere Kommentierung wird hier verzichtet - diese entnehmen Sie bitte der Beschreibung in Kapitel 13
    @Override
    public int getIndexOfChild(Object parent, Object child)
    {
        int n = getChildCount(parent);
        for (int i = 0; i < n; i++)
        {
            if (getChild(parent, i) == child)
            {
                return i;
            }
        }
        return -1;
    }

    @Override
    public Object getChild(Object parent, int index)
    {
        if (parent instanceof RootHimmelskoerper)
        {
            switch(index)
            {
                case 0:     return PLANETEN;
                default:    return MONDE;
            }
        }
        
        if (parent instanceof String)
        {
            if(parent.equals(MONDE))
            {
                return root.getMond(index);
            }
            else if (parent.equals(PLANETEN))
            {
                return root.getPlanet(index);
            }
        }
        return null;
    } 
        
    @Override
    public int getChildCount(Object parent)
    {
        // wenn der Knoten die Wurzel ist, wird eine Root-spezifische Methode aufgerufen
        if (parent instanceof RootHimmelskoerper)
        {
            // Mglichkeit 1: 
            // das bergebene Objekt in den Typ der Wurzel casten
            // RootHimmelskoerper temp = (RootHimmelskoerper) parent; 
            // dann die Root-spezifische Methode getAnzahlElemente aufrufen
            // return temp.getAnzahlElemente();
            
            // Mglichkeit 2: 
            // Da eine Referenz auf das Root-Objekt ohnehin besteht, kann diese Instanz genutzt werden: 
            // return root.getAnzahlElemente();
            
            // Eine abgekrzte Schreibweise fr Mglichkeit 1: 
            return ((RootHimmelskoerper) parent).getAnzahlElemente();
            // (so wird das in der Praxis gemacht)
        } 
        
        // Hier werden die Flle behandelt, wenn der Eintrag "Planeten" oder der Eintrag "Monde" angeklickt wird
        if(parent.toString().equals(MONDE))
        {
            return root.getAnzahlMonde();
        }
        else
        {
            return root.getAnzahlPlaneten();
        }
    } 

    @Override
    public boolean isLeaf(Object knoten)
    {
        // Wenn der Knoten vom Typ Himmelskoerper ist, dann ist er ein Blatt
        if(knoten instanceof Himmelskoerper)
            return true; 
        // sonst nicht    
        else 
            return false;
        // und so sieht der Code besser aus: 
        // return knoten instanceof Himmelskoerper;
        
        // alternative Implementierung: 
        // return getChildCount(knoten) == 0;
    }
    
    /**
     * Fragt den Wurzelknoten ab
     */ 
    @Override
    public Object getRoot()
    {
        return root;
    }

    /**
     * Methoden, die fr die Referenz zur Anzeige bentigt werden 
     */
    @Override
    public void addTreeModelListener(TreeModelListener listener)
    {
        // in der derzeitigen Implementierung nicht bentigt
    }

    @Override
    public void removeTreeModelListener(TreeModelListener listener)
    {
        // in der derzeitigen Implementierung nicht bentigt
    }
    
    @Override
    public void valueForPathChanged(TreePath treePath, Object value)
    {
        // in der derzeitigen Implementierung nicht bentigt
    }
}
