package JTree_4.view;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTree;
import javax.swing.WindowConstants;
import javax.swing.tree.DefaultTreeSelectionModel;
import javax.swing.tree.TreeSelectionModel;

/**
 * Stellt die View der Anwendung 
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */

public class GUI extends JFrame 
{
    public final JTree trvHimmelskoerper; 
    public final JLabel lblAnzeige;
    
    public GUI()
    {        
        // Objekt erzeugen
        trvHimmelskoerper = new JTree();
        
        // SelectionModel anlegen und bergeben
        DefaultTreeSelectionModel selection = new DefaultTreeSelectionModel();
        selection.setSelectionMode(TreeSelectionModel.CONTIGUOUS_TREE_SELECTION);
        trvHimmelskoerper.setSelectionModel(selection); 
                
        //Baum in eine ScrollPane legen
        JScrollPane scrTree = new JScrollPane(trvHimmelskoerper);
        
        // Splitpane anlegen und die ScrollPane mit dem Baum auf die linke Seite legen
        JSplitPane splTree = new JSplitPane();
        
        // Baum links platzieren
        splTree.setLeftComponent(scrTree);
        
        // Panel anlegen
        JPanel pnlAnzeige = new JPanel();
        
        // Panel auf die rechte Seite der SplitPane legen
        splTree.setRightComponent(pnlAnzeige);
        
        // Label-Instanz erzeugen
        lblAnzeige = new JLabel("Ich war eine Coladose");
        
        // Label auf Panel platzieren
        pnlAnzeige.add(lblAnzeige);
        
        // Splitpane auf das Fenster legen
        getContentPane().add(splTree);
        
        // Titel fr die GUI
        setTitle("Demo JTree");
        
        // Gre des Fensters festlegen
        setSize(500, 300);
        
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setVisible(true);
    }
}
