package JTree_5.model;

/**
 * Hlt zwei Arrays, eines fr Planeten, eines fr Monde
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */
public class RootHimmelskoerper
{
    /**
     * Array von Planeten
     */
    private Planet[] planeten;
    /**
     * Array von Monden
     */
    private Mond[] monde;
    
    /**
     * Legt Planeten und Monde an
     */
    public RootHimmelskoerper()
    {
        planeten = new Planet[]
        {
            new Planet("Merkur"),
            new Planet("Venus"),
            new Planet("Erde"),
            new Planet("Mars"),
            new Planet("Jupiter"),
            new Planet("Saturn"),
            new Planet("Uranus"),
            new Planet("Neptun")
        };
        
        monde = new Mond[]
        {
            new Mond("Luna", "Erde"),
            new Mond("Pan", "Saturn"),
            new Mond("Pandora", "Saturn"),
            new Mond("Atlas", "Saturn"),
            new Mond("Prometheus", "Saturn"),
            new Mond("Amalthea", "Jupiter"),
            new Mond("Thebe", "Jupiter"),
            new Mond("Europa", "Jupiter")
        };
    }
    
    /**
     * gibt den Mond an einem Index einer bestimmten Stelle im Array zurck
     * @param int Index im Array
     * @return Mond - der Mond an der gesuchten Index-Stelle
     */
    public Mond getMond(int index)
    {
        return monde[index];
    }
    
    /**
     * gibt den Planet an einem Index einer bestimmten Stelle im Array zurck
     * @param int Index im Array
     * @return Planet - der Planet an der gesuchten Index-Stelle
     */
    public Planet getPlanet(int index)
    {
        return planeten[index];
    }
    
    /**
     * gibt die Anzahl der gespeicherten Monde zurck
     * @return Anzahl der Monde
     */
    public int getAnzahlMonde()
    {
        return monde.length;
    }
     
    /**
     * gibt die Anzahl der gespeicherten Planeten zurck
     * @return Anzahl der Planeten
     */
    public int getAnzahlPlaneten()
    {
        return planeten.length;
    }
    
    /**
     * gibt zurck, wie viele Arten von Himmelskrpern gespeichert werden - derzeit zwei: Planeten und Monde
     */
    public int getAnzahlElemente()
    {
        return 2;
    }
    
    /**
     * String-Reprsentation des Objektes
     */
    @Override
    public String toString()
    {
        return "Himmelskrper";
    }
}
