package LookAndFeel_MVC.controller;

import LookAndFeel_MVC.model.Planet;
import LookAndFeel_MVC.model.Planetenverwaltung;
import LookAndFeel_MVC.view.GUI;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 * Stellt den Controller des Projektes
 * 
 * @author      Florian
 * @version     Kapitel 13
 */

public class Controller implements ListSelectionListener, ActionListener
{
    private final GUI view;
    private Planetenverwaltung model;

    public Controller(GUI view, Planetenverwaltung model)
    {
        this.view = view;
        this.model = model;
        view.mainMenu.mnPluto.addActionListener(this);
        view.lstPlaneten.addListSelectionListener(this);
        view.lstPlaneten.setModel(model);
    }    
        
    @Override
    public void actionPerformed(ActionEvent e)
    {
        model.loeschePluto();
        view.mainMenu.mnPluto.setEnabled(false);
    }
    
    @Override
    public void valueChanged(ListSelectionEvent e)
    {
        int index = e.getFirstIndex();
        Planet temp = model.getElementAt(index);
        String titel = temp.toString(); 
        view.fenster.setTitle(titel);
    }
}
