package MVC.controller;

import MVC.model.Planet;
import MVC.model.Planetenverwaltung;
import MVC.view.GUI;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
/**
 * Stellt den Controller des Projektes
 * 
 * @author      Florian
 * @version     Kapitel 13
 */

public class Controller implements ListSelectionListener // wird durch Action ersetzt: ActionListener
{
    private final GUI view;
    private Planetenverwaltung model;
    
    private Action actLoeschen = new AbstractAction("Weg mit Pluto!") 
    {
        public void actionPerformed(ActionEvent e) 
        {
            Controller.this.onLoesche();
        }
    };
    
    private final void onLoesche()
    {        
        model.loeschePluto();
        // kein direkter Zugriff mehr auf die Komponeten: view.mainMenu.mnPluto.setEnabled(false);
        actLoeschen.setEnabled(false);
    }
    
    public Controller(GUI view, Planetenverwaltung model)
    {
        this.view = view;
        this.model = model;
        // wird durch Action ersetzt: 
        // view.mainMenu.mnPluto.addActionListener(this);
        view.lstPlaneten.addListSelectionListener(this);
        view.lstPlaneten.setModel(model); 
        
        // Das Objekt Action bei den Komponenten anmelden: 
        view.btnLoeschen.setAction(actLoeschen);
        view.mainMenu.mnPluto.setAction(actLoeschen);
    }    
        
    /*
       DAS macht jetzt das Action-Objekt
    @Override
    public void actionPerformed(ActionEvent e)
    {
        model.loeschePluto();
        view.mainMenu.mnPluto.setEnabled(false);
    }
    */
    
    @Override
    public void valueChanged(ListSelectionEvent e)
    {
        int index = e.getFirstIndex();
        Planet temp = model.getElementAt(index);
        String titel = temp.toString(); 
        view.frmMain.setTitle(titel);
    }
}
