package flowLayout;

/**
 * Demonstriert die Verwendung des FlowLayout
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */
import java.awt.FlowLayout;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;

public class DemoFlowLayout
{
    public static void main(String[] args)
    {
        // Rahmen erzeugen 
        JFrame frmMain = new JFrame();
        
        // Container fr die Komponenten anlegen 
        JPanel pnlMain = new JPanel();
        
        // verschiedene Komponenten anlegen
        pnlMain.add(new JLabel("Bitte geben Sie Ihren Namen ein:"));
        pnlMain.add(new JTextField("Vor- und Nachname"));
        pnlMain.add(new JLabel("Wie alt sind Sie?"));
        JSlider sldAlter = new JSlider(18, 99);
        sldAlter.setPaintTicks(true);
        sldAlter.setMajorTickSpacing(10);
        sldAlter.setPaintLabels(true);
        pnlMain.add(sldAlter);
        pnlMain.add(new JLabel("Mchten Sie unseren Newsletter erhalten?"));
        pnlMain.add(new JCheckBox("Ja, ich will informiert werden", true));
        
        // LayoutManager erstellen
        FlowLayout layout = new FlowLayout();
        
        // Parameter fr das Layout
        // Standardeinstellung: layout.setAlignment(FlowLayout.CENTER);
        // layout.setAlignment(FlowLayout.LEFT);
        layout.setAlignment(FlowLayout.RIGHT);
        
        // horizontalen Abstand definieren
        layout.setHgap(20);
        
        // vertikalen Abstand definieren
        layout.setVgap(10);
        
        // LayoutManger dem Container zuweisen
        pnlMain.setLayout(layout);
        
        // Container auf das Fenster packen 
        frmMain.getContentPane().add(pnlMain);
        
        // Optimale Ausrichtung anfordern
        frmMain.pack();
        
        // Was passieren soll, wenn ...
        frmMain.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        // Fenster anzeigen
        frmMain.setVisible(true);
        
    }
}
