/**
 * In der Klasse Exception_3 wird ein einfaches Beispiel fr eine Exception-Behandlung angeboten.
 * Neu hier: Verwendung einer eigenen Exception-Klasse
 * 
 * @author      Florian
 * @version     Kapitel 14
 */
public class Exception_3
{
    private static double berechneWurzel(int wert) throws NegativerRadikantException
    {  
        if(wert <= 0) 
            throw new NegativerRadikantException("Negativer Radikant");
        else  
            return Math.sqrt(wert); 
    }
    
    private static void anzeigen()
    {
        double wurzel;
        int radikant = -5;
        
        try
        {
            wurzel = berechneWurzel(radikant);
            System.out.println(wurzel);
        }
        catch(NegativerRadikantException ex)
        {
            try
            { 
                System.out.println(ex.getMessage());
                radikant = Math.abs(radikant);
                wurzel = berechneWurzel(radikant);
                System.out.println(wurzel);
            } 
            catch(NegativerRadikantException e)
            {
                System.out.println(e.getMessage());
            } 
            finally
            {
                System.out.println("q. e. d.");
            }
        }
    }

    public static void main(String[] args)
    {
        anzeigen();
    }
}