
/**
 * Die Klasse DemoArrayList zeigt die Verwendung von ArrayLists
 * 
 * @author      Florian 
 * @version     Kapitel 15
 */
import java.util.*; 

public class DemoList
{
    public static void main(String[] args)
    {
        // bis Java 6: 
        // ArrayList<String> stringListe = new ArrayList<String>();
        // ab Java 7: 
        ArrayList<String> stringListe = new ArrayList<>(); 

        stringListe.add("Montag");
        stringListe.add("Dienstag");
        stringListe.add("Mittwoch");
        stringListe.add("Donnerstag");
        stringListe.add("Freitag");
        stringListe.add("Samstag");
        stringListe.add("Sonntag");

        // alle Werte ausgeben:        
        for(int i = 0; i < stringListe.size(); i++)
        {
            System.out.println("Element " + i + " = " + stringListe.get(i));
        }

        // zwei Werte lschen
        stringListe.remove("Samstag");
        stringListe.remove("Sonntag");
        System.out.println("SA und SO gelscht\n");

        // erneut alle Werte ausgeben
        for(int i = 0; i < stringListe.size(); i++)
        {
            System.out.println("Element " + i + " = " + stringListe.get(i));
        }

        for(String temp: stringListe)
        {
            int i = stringListe.indexOf(temp);
            System.out.println("Element " + i + " = " + temp);
        }

        // erwartet: zuerst "true" dann "false"
        System.out.println("Liste enthlt \"Montag\": " + stringListe.contains("Montag"));
        System.out.println("Liste enthlt \"Februar\": " + stringListe.contains("Februar"));

        // strende Null-Werte einfgen: 
        stringListe.add(1, null);
        stringListe.add(3, null);
        stringListe.add(4, null);
        stringListe.add(4, null);     

        // Liste mit null-Werten ausgeben: 
        System.out.println("\nEnthlt strende null-Werte:");
        for(int i = 0; i < stringListe.size(); i++)
        {
            System.out.println("Element " + i + " = " + stringListe.get(i));
        }

        // null-Werte lschen
        while(stringListe.contains(null))
        {
            System.out.println("\tSuche null-Werte ...");
            stringListe.remove(null);
        }

        // Liste zur Kontrolle erneut ausgeben: sie enthlt keine null-Werte mehr
        System.out.println("\nOhne null-Werte:");
        for(int i = 0; i < stringListe.size(); i++)
        {
            System.out.println("Element " + i + " = " + stringListe.get(i));
        }

        // strende Null-Werte einfgen: 
        stringListe.add(1, null);
        stringListe.add(3, null);
        stringListe.add(4, null);        
        stringListe.add(4, null);

        // eine Liste fr die null-Werte anlegen
        // bis Java 6:
        // List<String> nullListe = new ArrayList<String>();
        // ab Java 7 Diamond Operator: 
        List<String> nullListe = new ArrayList<>();

        // von der Klasse Collections eine Liste mit den null-Eintrgen anfordern
        nullListe = Collections.singletonList(null);

        // aus der Liste entfernen
        stringListe.removeAll(nullListe);

        /*
         * krzere Schreibweise: 
         * stringListe.removeAll(Collections.singletonList(null));
         */

        List<String> uWochentage = new ArrayList<>();
        uWochentage = Collections.unmodifiableList(stringListe);
        // der folgende Aufruf ist unzulssig und wirft eine Exception (daher auskommentiert): 
        // uWochentage.add("Hrtetest"); 

        // sortieren und mischen:
        List<String> jahreszeiten = new ArrayList<>();
        jahreszeiten.add("Winter");
        jahreszeiten.add("Frhjahr");
        jahreszeiten.add("Sommer");
        jahreszeiten.add("Herbst");        

        // Liste durchmischen
        Collections.shuffle(jahreszeiten);
        System.out.println("\n Eine gemischte Liste ausgeben: ");
        for(String temp : jahreszeiten)
            System.out.println(temp);

        // Liste nach dem Alphabet sortieren: 
        Collections.sort(jahreszeiten);
        System.out.println("\n Eine sortierte Liste ausgeben: ");
        for(String temp : jahreszeiten)
            System.out.println(temp);
            
        // Iterator 
        System.out.println("\nIterator demonstrieren:");
        Iterator it = jahreszeiten.iterator();
        while(it.hasNext()) 
        {
            String temp = (String)it.next();
            System.out.println(temp);
        }

        System.out.println("\nUnd jetzt mit dem ListIterator:");
        ListIterator li = jahreszeiten.listIterator();
        while(li.hasNext())
        {
            String temp = (String)li.next();
            System.out.println(temp);            
        }

        System.out.println("\nUnd jetzt rckwrts:");
        while(li.hasPrevious())
        {
            String temp = (String)li.previous();
            System.out.println(temp);            
        }
    }
}
