
/**
 * Die Klasse DemoListBier_3 ist die 3. Version der Demonstration, 
 * wie eine Sammlung eine eigenen Klasse sortiert werden kann. Die 
 * Sortierung mit Comparable funktioniert. Hier ist die Klasse LeichtBier
 * neu eingefgt. 
 * 
 * @author      Florian 
 * @version     Kapitel 15
 */
import java.util.*;

public class DemoListBier_3
{ 
    public static class LeichtBier extends Bier
    {
        // eigene Datenfelder
        
        // eigene Methoden
        
        public LeichtBier(int produktnummer, String bezeichnung, String herkunft)
        {
            super(produktnummer, bezeichnung, herkunft);
        }
    }
    
    public static class Bier implements Comparable<Bier>
    {
        private int produktnummer;
        private String bezeichnung;
        private String herkunft;
        
        public Bier(int produktnummer, String bezeichnung, String herkunft)
        {
            this.produktnummer = produktnummer;
            this.bezeichnung = bezeichnung; 
            this.herkunft = herkunft;
        }
 
        @Override
        public int compareTo(Bier vergleich)
        {
            int result = 0;
            result = bezeichnung.compareTo(vergleich.bezeichnung);            
            return result;
        }
        
        @Override
        public int hashCode()
        {
            System.out.println("Jetzt wird die hashCode-Methode aufgerufen");
            return produktnummer * (bezeichnung.hashCode() + herkunft.hashCode());
        }
        
        @Override
        public boolean equals(Object obj)
        {    
            System.out.println("Jetzt wird die equals-Methode aufgerufen");
            if (this == obj)
            {
                return true;
            }
            
            if (obj == null)
            {
                return false;
            }
            
            if (this.getClass() != obj.getClass())
            {
                return false;
            }    
            
            Bier temp = (Bier) obj;  
            return
                produktnummer == temp.produktnummer && 
                bezeichnung.equalsIgnoreCase(temp.bezeichnung) &&
                herkunft.equalsIgnoreCase(temp.herkunft);
        }
        
        @Override
        public String toString()
        {
            return produktnummer + ", " + bezeichnung;
        }
    }
    
    public static void main(String[] args)
    {   
        List <Bier> angebot = new ArrayList<>();
        angebot.add(new LeichtBier(4714, "Augustiner", "Mnchen (Freistaat Bayern)"));
        angebot.add(new Bier(4711, "Flensburger", "Flensburg"));
        angebot.add(new LeichtBier(4715, "Dominikaner Bru", "Lekkerland")); 
        angebot.add(new LeichtBier(4712, "Rothaus-Pils", "Grafenhausen (Groherzogtum Baden)"));
        angebot.add(new Bier(4715, "Dominikaner Bru", "Lekkerland")); 
        angebot.add(new Bier(4713, "Franziskaner", "Mnchen (Freistaat Bayern)"));
     
        Collections.sort(angebot);
        for(Bier bier: angebot)
        {
            // ausgegeben wird die Rckgabe der toString-Methode
            System.out.println(bier);
        }
    }
}
