
/**
 * Die Klasse DemoSet fhrt die Verwendung der Schnittstelle Set vor
 * Die Dokumentation entnehmen Sie bitte dem Buch
 * 
 * @author      Florian 
 * @version     Kapitel 15
 */
import java.util.*;

public class DemoSet
{ 
    public static class Bier
    {
        private int produktnummer;
        private String bezeichnung;
        private String herkunft;

        public Bier(int produktnummer, String bezeichnung, String herkunft)
        {
            this.produktnummer = produktnummer;
            this.bezeichnung = bezeichnung; 
            this.herkunft = herkunft;
        } 

        @Override
        public String toString()
        {
            return produktnummer + ", " + bezeichnung;
        }
    }

    public static void main(String[] args)
    {        
        Set<Bier> angebot = new HashSet<>();
        //Set<Bier> angebot = new TreeSet();
        angebot.add(new Bier(4711, "Flensburger", "Flensburg"));
        angebot.add(new Bier(4715, "Dominikaner Bru", "Lekkerland")); 
        angebot.add(new Bier(4713, "Franziskaner", "Mnchen (Freistaat Bayern)"));
        angebot.add(new Bier(4712, "Rothaus-Pils", "Grafenhausen (Groherzogtum Baden)"));
        angebot.add(new Bier(4714, "Augustiner", "Mnchen (Freistaat Bayern)"));
        angebot.add(new Bier(4715, "Dominikaner Bru", "Lekkerland")); 

        // Collections.sort(angebot);
        System.out.println("\nMit der for-each-Schleife iterieren:");
        // mit der for-each-Schleife iterieren
        for(Bier bier: angebot)
        {
            // ausgegeben wird die Rckgabe der toString-Methode
            System.out.println(bier);
        }

        // Iterator-Objekt
        System.out.println("\nMit einem Iterator-Objekt:");
        Iterator it = angebot.iterator();
        while(it.hasNext())
        {
            System.out.println(it.next());
        }
    }
}
