/**
 * Die Klasse MyArray beschreibt einen neuen Datentyp, der flexiblere Arrays ermglicht. 
 * 
 * @author      Florian 
 * @version     Kapitel 15
 */

import java.util.Arrays;

public class MyArray 
{
    private Object[] elementData = new Object[10];
    private int size = 0; 
    
    public void add(Object o)
    {
        if (size == elementData.length) 
        {
            elementData = Arrays.copyOf(elementData, elementData.length * 1);
        }
        elementData[size] = o;
        size++;
    }
    
    public int size()
    {
        return size; 
    }
    
    public Object get(int index)
    { 
        if(index >= size)
        {
            throw new IndexOutOfBoundsException("Index: " + index + ", Size: " + size);
        }
        return elementData[index];
    } 
}
