/**
 * Die Klasse MyArrayMitGenerics beschreibt einen neuen Datentyp, der flexiblere Arrays ermglicht, 
 * und dabei von Generics Gebrauch macht
 * 
 * @author      Florian 
 * @version     Kapitel 15
 */

import java.util.Arrays;

public class MyGenericArray<T>
{
    private Object[] elementData = new Object[10];
    private int size = 0; 
    
    public void add(T t)
    {
        if (size == elementData.length) 
        {
            elementData = Arrays.copyOf(elementData, elementData.length * 2);
        }
        elementData[size] = t;
        size++;
    }
    
    public int size()
    {
        return size; 
    }
    
    public T get(int index)
    { 
        if(index >= size)
        {
            throw new IndexOutOfBoundsException("Index: " + index + ", Size: " + size);
        }
        return (T)elementData[index];
    } 
}
