
/**
 * Produziert Bier, das der Verbraucher entnehmen kann. Sowohl die Menge Bier als auch die Wartezeiten sind jeweils 
 * zufallsgesteuert; um das System von wait() und notify() zu veranschaulichen, wird jeweils eine Zeitmessung vorgenommen. 
 * 
 * @author      Florian 
 * @version     Kapitel 16
 */
import java.util.*;

public class Produzent extends Thread
{
    /**
     * ArrayList, in der die Daten gespeichert werden
     */
    private ArrayList<String> bier;
    
    /*
     * Konstruktor 
     * @param ArrayList Speicher fr das Bier
     */
    public Produzent(ArrayList<String> bier)
    { 
        this.bier = bier;
    }
    
    /*
     * hier werden die Daten erzeugt
     */
    public void run()
    {
        String name = currentThread().getName();
        
        System.out.println("Ab jetzt wird Bier von " + name + " produziert");
        while(!isInterrupted())   
        {
            // die Instanz muss gegen die Verbraucher synchronisiert werden
            synchronized(bier)
            {  
                for(int i = 0; i < (int)(Math.random() * 15); i++)
                {                    
                    bier.add("Jever-Java");                 
                }
                
                System.out.println(name + " hat Bier erzeugt. Bestand jetzt: " + bier.size());   
                
                // eventuelle Verbraucher informieren
                bier.notify();
            }
            
            // zufllig bestimmen, wie lange gewartet werden soll
            try
            {
                Thread.sleep((int)(Math.random() * 1000));
            }
            catch(InterruptedException ex)
            {
                return;
            }
        }
    }
}
