
/**
 * Eine Instanz dieser Klasse entnimmt Bier aus der gemeinsamen Datenbasis. Wie beim Produzenten wird angezeigt, 
 * wann eine Aktion stattfindet. 
 * 
 * @author      Florian 
 * @version     Kapitel 16
 */
import java.util.*;

public class Verbraucher extends Thread
{
    /**
     * Referenz auf die gemeinsame Datenbasis
     */
    private ArrayList<String> bier;

    /**
     * Konstruktor - bergibt die Referenz auf die gemeinsame Datenbasis 
     */
    public Verbraucher(ArrayList<String> bier)
    { 
        this.bier = bier; 
    }

    /**
     * entnimmt Bier, sofern welches da ist
     */
    public void run()
    {
        String name = currentThread().getName();
        System.out.println(name + " will ab jetzt Bier konsumieren.");
        while(!isInterrupted())
        {
            // auf die gemeinsame Datenbasis darf nur ein Thread zugreifen
            synchronized(bier)
            { 
            if(bier.size() > 0)
            {
                bier.remove(0);
                System.out.println("\t" + name + " entnimmt eine Flasche Jever-Java. Bestand jetzt: " + bier.size());
            }
            else
            {
                try
                {
                    System.out.println("\t" + name + " wartet auf neues Bier");
                    bier.wait();
                }
                catch(InterruptedException ex)
                {
                    return;
                }
            }
            }            
        }
    }
}
