/**
 * Die Klasse Stoppuhr fhrt vor, wie ein Thread gestartet und beendet wird. 
 * 
 * @author      Florian
 * @version     Kapitel 16
 */
import java.util.*;
import java.text.*;
import java.io.*;

public class Stoppuhr 
{
    private static class StoppuhrThread extends Thread
    {
        private SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");   

        public void run()
        {
            while(!isInterrupted())   
            {
                Date time = new Date();
                System.out.println(sdf.format(time));
                try
                {
                    sleep(1000);
                }
                catch(InterruptedException ex)
                {
                    System.out.println(ex.getMessage());
                    interrupt();
                    // return;
                }
            }
        }
    } 

    public static void main(String[] args)
    {
        System.out.println("Bitte drcken Sie die Enter-Taste, um die Stoppuhr zu starten.");
        BufferedReader bin = new BufferedReader(new InputStreamReader(System.in) );
        String text;

        try
        {
            text = bin.readLine();
        }
        catch(Exception ex)
        {
            System.out.println(ex.getMessage());
        }

        Date anfang = new Date();

        System.out.println("Zum Beenden bitte erneut Enter-Taste drcken.");

        Thread timer = new StoppuhrThread();
        timer.start(); 

        try
        {
            Thread.sleep(5000);
        }
        catch(InterruptedException ex)
        {
            System.out.println(ex.getMessage());
        }

        bin = new BufferedReader(new InputStreamReader(System.in));

        try
        {
            text = bin.readLine();
        }
        catch(Exception ex)
        {
            System.out.println(ex.getMessage());
        }

        timer.interrupt();
        Date ende = new Date();

        long laufzeit = ende.getTime() - anfang.getTime();

        System.out.println("Laufzeit in Millisekunden: " + laufzeit);
    }
}
