
/**
 * Die Klasse TimerDemo zeigt ein Beispiel fr die Anwendung von Timer / TimerTask
 * 
 * @author      Florian 
 * @version     Kapitel 16
 */
import java.util.*;

public class TimerDemo
{
    /**
     * Legt eine Aufgabe an, die der Timer ausfhren soll
     */
    private static class Kekse extends TimerTask
    {
        public void run()
        {
            System.out.println("\tKekse holen!");    
        }
    }

    public static void main(String[] args)
    {
        // Instanz der Klasse Timer anlegen
        Timer hinweis = new Timer();
        
        // Anonyme Klasse, die einen TimerTask deklariert
        TimerTask aufgabe_1 = new TimerTask()
        {
            // anstelle der anonymen Klasse htte auch hier eine innere Klasse deklariert werden knnen
            public void run()
            {
                System.out.println("Kaffee holen!");            
            }
        };        
        
        // Die Aufgabe Nr. 1 an den Timer bergeben, keine Wartezeit, alle 1000 Millisekunden ausfhren
        hinweis.schedule(aufgabe_1, 0, 1000);   
        
        // eine weitere Aufgabe 
        TimerTask aufgabe_2 = new Kekse();
        
        // die zweite Aufgabe an den Timer bergeben, 1000 Millisekunden warten und dann alle 5000 Millisekunden ausfhren
        hinweis.schedule(aufgabe_2, 1000, 5000);   
        
        try
        {
            // den main-Thread 10 Sekunden schlafen legen
            Thread.sleep(10000);
        }
        catch(InterruptedException ex)
        {
            
        }
        
        // Timer stoppen
        hinweis.cancel();
    }
}
