
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * Demonstriert die Verwendung von InputStream und OutputStream
 * 
 * @author      Florian
 * @version     Kapitel 17
 */
public class DemoStream
{
    public static void main(String[] args)
    {
        String dateiname = "Tastatureingaben.txt";

        try (
                InputStream quelle = System.in;
                OutputStream ziel = new FileOutputStream(dateiname))
        {

            System.out.println("Bitte geben Sie Text ein: ");
            int eingabe;
            do
            {
                eingabe = quelle.read();
                ziel.write(eingabe);
            }
            while (eingabe != -1);
        }
        catch (IOException ex)
        {
            System.out.println(ex.getMessage());
        }
    }
}
