
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;

/**
 * Demonstriert die Verwendung von Reader und Writer
 * 
 * @author      Florian
 * @version     Kapitel 17
 */
public class DemoReaderWriter
{
    public static void main(String[] args)
    {
        String dateiname = "Eingaben.txt";

        try (
                Reader quelle = new InputStreamReader(System.in);
                Writer ziel = new FileWriter(dateiname))
        {
            System.out.println("Bitte geben Sie Text ein: ");
            int eingabe;
            do
            {
                eingabe = quelle.read();
                ziel.write(eingabe);
            }
            while (eingabe != -1);
        }
        catch (IOException ex)
        {
            System.out.println(ex.getMessage());
        }

        // Jetzt noch die Datei ausgeben lassen 
        try (
                Reader quelle = new FileReader(dateiname);
                Writer ziel = new OutputStreamWriter(System.out))
        {
            System.out.println("\n*******\nZur Kontrolle nochmal ausgeben");
            int eingabe;
            do
            {
                eingabe = quelle.read();
                ziel.write(eingabe);
            }
            while (eingabe != -1);
        }
        catch (IOException ex)
        {
            System.out.println(ex.getMessage());
        }
    }
}
