
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Writer;

/**
 * Demonstriert die Verwendung von BufferedReader und BufferedWriter
 * 
 * @author      Florian
 * @version     Kapitel 17
 */
public class DemoBuffered
{
    public static void main(String[] args)
    {
        String dateiname = "Eingaben.txt";
        String inhalt = new String();

        // Daten von der Tastatur einlesen
        try (
                InputStream is = System.in;
                InputStreamReader isr = new InputStreamReader(is);
                BufferedReader br = new BufferedReader(isr))
        {
            System.out.println("Bitte geben Sie Text ein: ");
            String eingabe = new String();
            while ((eingabe = br.readLine()) != null)
            {
                inhalt += eingabe + "\n";
            }
        }
        catch (IOException ex)
        {
            System.out.println(ex.getMessage());
        }

        // Daten in Datei schreiben
        try (
                Writer fw = new FileWriter(dateiname);
                BufferedWriter bfw = new BufferedWriter(fw))
        {
            bfw.write(inhalt);
        }
        catch (IOException ex)
        {
            System.out.println(ex.getMessage());
        } 
    }
}
