
import java.io.IOException;
import java.nio.file.FileStore;
import java.nio.file.FileSystem;
import java.nio.file.FileSystems;
import java.nio.file.Path;
import javax.swing.filechooser.FileSystemView;

/**
 * Startet den FileWhisperer
 * 
 * @author      Florian 
 * @version     Kapitel 17
 */
public class ApplStart
{
    private static FileSystem fs = FileSystems.getDefault();

    public static void main(String[] args) throws IOException
    {
        for (FileStore store : fs.getFileStores())
        {
            long gesamt = store.getTotalSpace() >> 30;
            long verfuegbar = store.getUsableSpace() >> 30;
            long unbenutzt = store.getUnallocatedSpace() >> 30;
            System.out.println(store + " " + store.name() + " Typ: " + store.type() + " frei " + verfuegbar + " GB von insgesamt " + gesamt + " GB, unbenutzt: " + unbenutzt);
        }
        Iterable<Path> roots = fs.getRootDirectories();
        for (Path temp : roots)
        {
            System.out.println(temp);
        }


        try
        {
            FileSystemView system = FileSystemView.getFileSystemView();
            Path root = (system.getHomeDirectory()).toPath();
            new Controller(new Dateisystem(root), new GUI());
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }
}
