
import java.nio.file.Path;
import java.nio.file.Paths;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.WindowConstants;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;
import javax.swing.tree.DefaultTreeSelectionModel;
import javax.swing.tree.TreeSelectionModel;

/**
 * Stellt die View der Anwendung 
 *  
 * @author      Florian 
 * @version     Kapitel 17
 */
public class GUI extends JFrame
{
    public final JTree trvDateisystem = new JTree();
    private final JTextArea details = new JTextArea("Ich war eine Coladose");
    public final JTable tblDateiliste = new JTable();

    public GUI()
    {
        // SelectionModel anlegen und uebergeben
        DefaultTreeSelectionModel selection = new DefaultTreeSelectionModel();
        selection.setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        trvDateisystem.setSelectionModel(selection);

        // Renderer anlegen
        trvDateisystem.setCellRenderer(new MyRenderer());  

        // Splitpane anlegen 
        JSplitPane splTree = new JSplitPane();

        // Baum links platzieren
        splTree.setLeftComponent(new JScrollPane(trvDateisystem));

        // SplitPane fr rechts anlegen
        JSplitPane splDateien = new JSplitPane();
        splDateien.setOrientation(JSplitPane.VERTICAL_SPLIT);
        splTree.setRightComponent(splDateien);

        // Tabelle mit den Datei-Infos oben
        splDateien.setLeftComponent(new JScrollPane(tblDateiliste));

        // TextArea fr Detail-Anzeige auf die untere Hlfte der SplitPane legen
        splDateien.setRightComponent(new JScrollPane(details));

        // Splitpane auf das Fenster legen
        getContentPane().add(splTree);

        // Titel fuer die GUI
        setTitle("my FileWhisperer");

        // mit maximaler Vergrerung anzeigen
        this.setExtendedState(MAXIMIZED_BOTH);

        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setVisible(true);
    }

    /**
     * Text anzeigen lassen
     * @param text 
     */
    public void ausgebenText(String text)
    {
        details.setText(text);
    }

    public Path getSelectedTableRow(int i)
    {
        Attribute daten = (Attribute) tblDateiliste.getModel();
        return daten.getPathAt(i);
    }
}
