import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;

/**
 * Die Klasse Session verarbeitet die Anfrage. 
 * 
 * @author      Florian 
 * @version     Kapitel 18
 */
public class Session implements Runnable
{
    private final Socket socket;

    public Session(Socket socket)
    {
        this.socket = socket;
    }

    public void run()
    {
        try (
                // vom Socket einen InputStream beziehen
                InputStream streamIn = socket.getInputStream();
                ObjectInputStream objectIn = new ObjectInputStream(streamIn);
                // vom Socket einen InputStream beziehen
                OutputStream streamOut = socket.getOutputStream();
                ObjectOutputStream objectOut = new ObjectOutputStream(streamOut);)
        {

            Aufgabe aufgabe;
            while ((aufgabe = (Aufgabe) objectIn.readObject()) != null)
            {
                try
                {
                    Thread.sleep(2000);
                }
                catch (InterruptedException ex)
                {
                    System.out.println(ex.getMessage());
                }

                if (aufgabe instanceof Rechenaufgabe)
                {
                    if (aufgabe instanceof AddRechenaufgabe)
                    {
                        AddRechenaufgabe rechenAufgabe = (AddRechenaufgabe) aufgabe;
                        int x = rechenAufgabe.getX();
                        int y = rechenAufgabe.getY();
                        rechenAufgabe.setErgebnis(x + y);
                        aufgabe = rechenAufgabe;
                    }
                    else
                    {
                        if (aufgabe instanceof DiffRechenaufgabe)
                        {
                            DiffRechenaufgabe rechenAufgabe = (DiffRechenaufgabe) aufgabe;
                            int x = rechenAufgabe.getX();
                            int y = rechenAufgabe.getY();
                            rechenAufgabe.setErgebnis(x - y);
                            aufgabe = rechenAufgabe;
                        }
                        else
                        {
                            if (aufgabe instanceof DivRechenaufgabe)
                            {
                                DivRechenaufgabe rechenAufgabe = (DivRechenaufgabe) aufgabe;
                                // impliziter Cast auf h?herwertigen Datentyp 
                                double x = rechenAufgabe.getX();
                                // impliziter Cast auf h?herwertigen Datentyp 
                                double y = rechenAufgabe.getY();
                                rechenAufgabe.setErgebnis(x / y);
                                aufgabe = rechenAufgabe;
                            }
                        }
                    }
                }

                // an Client uebergeben:  
                objectOut.writeObject(aufgabe);
            }
        }
        catch (EOFException ex)
        {
            // keine weiteren Daten- EOFException ist in Ordnung
        }
        catch (IOException|ClassNotFoundException ex)
        {
            System.out.println(ex.getMessage());
        }
    }
}
