import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.ArrayList;

/**
 * Die Klasse MyClient ist ein Client fuer den Server
 * 
 * @author      Florian
 * @version     Kapitel 18
 */
public class MyClient
{
    /**
     * Die Portnummer
     */
    private int port = 4711;

    /**
     * Verarbeitungsroutine 
     */
    public void abgehts()  
    {
        try (
                Socket socket = new Socket("127.0.0.1", port);
                // vom Socket einen OutputStream beziehen
                OutputStream streamOut = socket.getOutputStream();
                // eine Instanz von ObjectOutputStream mit dem OutputStream verketten: 
                ObjectOutputStream objectOut = new ObjectOutputStream(streamOut);
                // vom Socket einen OutputStream beziehen
                InputStream inputStream = socket.getInputStream();
                // eine Instanz von ObjectInputStream mit dem InputStream verketten: 
                ObjectInputStream objectIn = new ObjectInputStream(inputStream);)
        {
            ArrayList<Aufgabe> aufgabenListe = new ArrayList<>();
            aufgabenListe.add(new DiffRechenaufgabe(79, 2));
            aufgabenListe.add(new AddRechenaufgabe(40, 2));
            for (int i = 20; i > 0; i--)
            {
                aufgabenListe.add(new DivRechenaufgabe(11, i));
            }

            for (Aufgabe aufgabe : aufgabenListe)
            {
                objectOut.writeObject(aufgabe);
                Aufgabe antwort = (Aufgabe) objectIn.readObject();
                System.out.println(antwort);
            }
        }
        catch (IOException | ClassNotFoundException ex)
        {
            System.out.println(ex.getMessage());
        }
    }

    public static void main(String[] args)
    {
        new MyClient().abgehts();
    }
}
