
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.HashMap;

/**
 * Die Klasse MyServer ist einfacher Server
 * 
 * @author      Florian
 * @version     Kapitel 18
 */
public class MyServer
{
    /**
     * Die Portnummer
     */
    private static int port = 4711;
    /**
     * Hashmap, die im String den Klassennamen der Aufgabe enthaelt - Key
     * und einen zugehoerigen Service - Value
     */
    private final HashMap<String, Service> services = new HashMap<>();

    /**
     * Konstruktor der Klasse; traegt Key und Value in die HashMap services ein
     */
    public MyServer()
    {
        services.put("AddRechenaufgabe", new AddService());
        services.put("DiffRechenaufgabe", new DiffService());
        services.put("DivRechenaufgabe", new DivService());
    }

    /**
     * startet den Server
     */
    public void abgehts()
    {
        try (ServerSocket serverSocket = new ServerSocket(port);)
        {
            while (true)
            {
                System.out.println("Server wartet auf Anfragen ...");
                Socket socket = serverSocket.accept();
                System.out.println("Anfrage akzeptiert ...");

                Session session = new Session(socket, services);
                Thread sessionThread = new Thread(session);
                sessionThread.start();
            }
        }
        catch (IOException ex)
        {
            System.out.println(ex.getMessage());
        }
    }

    public static void main(String[] args)
    {
        new MyServer().abgehts();
    }
}
