
/**
 * Demonstriert die Arbeit mit Datenbanken
 * 
 * @author      Florian 
 * @version     Kapitel 19
 */
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Demonstriert die Arbeit mit Datenbanken
 * 
 * @author      Florian 
 * @version     Kapitel 19
 */
public class JDBCDemo_1
{
    public static void main(String args[])
    {
        // URL der Datenbank 
        String url = "jdbc:mysql://localhost:3306/mysql";

        // Treiber laden
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
        }
        catch (ClassNotFoundException ex)
        {
            System.out.println("Der Treiber konnte nicht geladen werden: " + ex.getMessage());
        }

        // try-with-resource
        try (
                Connection con = DriverManager.getConnection(url);
                Statement stmt = con.createStatement())
        {
            // SQL-Befehl zum Anlegen einer Datenbank
            String befehl = "CREATE DATABASE Terminverwaltung";
            // der Befehl zum Lschen einer DB ist:
            // String befehl = "DROP DATABASE Terminverwaltung";

            // Anzahl betroffene Zeilen
            int anzahlBZ;

            // Befehl absetzen
            anzahlBZ = stmt.executeUpdate(befehl);
            System.out.println("ordnungsgem ausgefhrt mit " + anzahlBZ + " betroffenen Zeilen");
        }
        catch (SQLException ex)
        {
            System.out.println("Fehler beim Anlegen der Datenbank: " + ex.getMessage());
        }
    }
}