
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Demonstriert die Arbeit mit Datenbanken - PreparedStatements
 * 
 * @author      Florian 
 * @version     Kapitel 19
 */
public class JDBCDemo_10
{
    public static void main(String args[])
    {
        // URL der Datenbank 
        String url = "jdbc:mysql://localhost:3306/mysql";
        // Befehl an die Datenbank 
        String befehl = "SELECT Datum FROM Verabredungen WHERE PartnerID IN (SELECT ID FROM Partner WHERE Partnername like ?)";

        // Treiber laden
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
        }
        catch (ClassNotFoundException ex)
        {
            System.out.println("Der Treiber konnte nicht geladen werden: " + ex.getMessage());
        }
 
        try (
                Connection con = DriverManager.getConnection(url);
                PreparedStatement stmt = con.prepareStatement(befehl);)
        {   
            // an die Stelle des 1. Fragezeichen wird "Dieter" eingetragen"
            stmt.setString(1, "%Dieter%");
            try (ResultSet daten = stmt.executeQuery();)
            {
                System.out.println("Verabredungen mit Dieter:");
                while (daten.next())
                {
                    //Ausgabe 
                    System.out.println(daten.getString("Datum"));
                }
            }
        }
        catch (SQLException ex)
        {
            ex.printStackTrace();
        }  
    }
}
