
/**
 * Demonstriert die Arbeit mit Datenbanken
 * 
 * @author      Florian 
 * @version     Kapitel 19
 */
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

/**
 * Demonstriert die Arbeit mit Datenbanken
 * 
 * @author      Florian 
 * @version     Kapitel 19
 */
public class JDBCDemo_2
{
    public static void main(String args[])
    {
        // URL der Datenbank 
        String url = "jdbc:mysql://localhost:3306/Terminverwaltung";

        // Treiber laden
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
        }
        catch (ClassNotFoundException ex)
        {
            System.out.println("Der Treiber konnte nicht geladen werden: " + ex.getMessage());
        }

        // Verbindung herstellen  
        try (
                Connection con = DriverManager.getConnection(url);
                Statement stmt = con.createStatement();)
        {
            // SQL-Befehl zum Anlegen einer Datenbank
            String[] befehle = new String[3];

            befehle[0] = "CREATE TABLE Ort";
            befehle[1] = "CREATE TABLE Partner";
            befehle[2] = "CREATE TABLE Kategorie";
            /* Tabellen lschen
            befehle[0] = "DROP TABLE Ort";
            befehle[1] = "DROP TABLE Partner";
            befehle[2] = "DROP TABLE Kategorie";
             */

            // Autocommit ausschalten
            con.setAutoCommit(false);

            try
            {
                // Befehl absetzen
                for (String befehl : befehle)
                {
                    stmt.executeUpdate(befehl);
                    System.out.println("Tabelle angelegt mit Befehl: " + befehl);
                }

                // bergebene Befehle ausfhren
                con.commit();
                System.out.println("ordnungsgem abgeschlossen");
            }
            catch (SQLException ex)
            {
                System.out.println(ex.getMessage());
                con.rollback();
            }

            // Autocommit wieder einschalten
            con.setAutoCommit(true);
        }
        catch (SQLException ex)
        {
            System.out.println("Fehler beim Anlegen der Tabellen: " + ex.getMessage());
        }
    }
}
