
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;


/**
 * Demonstriert die Arbeit mit Datenbanken - inner join ber zwei Tabellen
 * 
 * @author      Florian 
 * @version     Kapitel 19
 */ 

public class JDBCDemo_6
{
    public static void main(String args[])
    {
        // URL der Datenbank 
        String url = "jdbc:mysql://localhost:3306/mysql";
        // Abfrage an die Datenbank         
        String befehl = "SELECT Datum, OrtID, KategorieID, Partnername, Bemerkung FROM Verabredungen INNER JOIN Partner ON Verabredungen.PartnerID = Partner.ID";

        // Treiber laden
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
        }
        catch (ClassNotFoundException ex)
        {
            System.out.println("Der Treiber konnte nicht geladen werden: " + ex.getMessage());
        }

        try (
                Connection con = DriverManager.getConnection(url);
                Statement stmt = con.createStatement();
                ResultSet daten = stmt.executeQuery(befehl);)
        {
            ResultSetMetaData meta = daten.getMetaData();
            int spaltenZahl = meta.getColumnCount();
            String[] attribute = new String[spaltenZahl];

            int zaehler = 0;
            while (daten.next())
            {
                zaehler++;
                System.out.println(zaehler + ". Verabredung: ");

                for (int i = 0; i < spaltenZahl; i++)
                {
                    System.out.print("\t" + attribute[i] + ": " + daten.getString(i + 1) + "\t");
                }
                System.out.println();
            }
        }
        catch (SQLException e)
        {
            e.printStackTrace();
        }
    }
}