import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;


/**
 * Demonstriert die Arbeit mit Datenbanken - where-Klausel => Lschen von einzelnen Datenstzen
 * 
 * @author      Florian 
 * @version     Kapitel 19
 */ 

public class JDBCDemo_8
{
    public static void main(String args[])
    {
        // URL der Datenbank 
        String url = "jdbc:mysql://localhost:3306/mysql";
        // Befehl an die Datenbank
        String befehl = "DELETE FROM Verabredungen WHERE PartnerID IN (SELECT ID FROM Partner WHERE Partnername like '%Heinz%')";

        // Treiber laden
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
        }
        catch (ClassNotFoundException ex)
        {
            System.out.println("Der Treiber konnte nicht geladen werden: " + ex.getMessage());
        }

        try (
                Connection con = DriverManager.getConnection(url);
                Statement stmt = con.createStatement();)
        {
            int zeilen = stmt.executeUpdate(befehl);
            System.out.println(zeilen + " Zeilen gelscht.");
        }
        catch (SQLException e)
        {
            e.printStackTrace();
        }
    }
}
