import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
 
/**
 * Demonstriert die Arbeit mit Datenbanken - where-Klausel => ?ndern eines Datensatzes
 * 
 * @author      Florian 
 * @version     Kapitel 19
 */ 
public class JDBCDemo_9
{
    public static void main(String args[])
    {
        // URL der Datenbank 
        String url = "jdbc:mysql://localhost:3306/mysql";
        // Befehl an die Datenbank 
        String befehl = "UPDATE Verabredungen SET Kategorie = 1, Datum = '15. August' WHERE PartnerID IN (SELECT ID FROM Partner WHERE Partnername like '%Hilde%')";
        
        // Treiber laden
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
        }
        catch (ClassNotFoundException ex)
        {
            System.out.println("Der Treiber konnte nicht geladen werden: " + ex.getMessage());
        }

        try (
                Connection con = DriverManager.getConnection(url);
                Statement stmt = con.createStatement();)
        { 
            int zeilen = stmt.executeUpdate(befehl);
            System.out.println("Betroffene Zeilen: " + zeilen);
        }
        catch (SQLException e)
        {
            e.printStackTrace();
        }
    }
}