
/**
 * Die Klasse Geburtstagskalender erstellt einen Geburtstagkalender.
 * Es gibt fr jeden Tag im Monat fr jeden Monat im Jahr einen String. 
 * 
 * @author      Florian 
 * @version     Kapitel 7
 */
public class Geburtstagskalender_V2
{ 
    String[][] gebTag = new String[12][];
    
    public Geburtstagskalender_V2()
    { 
        initialisieren();
    }
    
    /**
     * Trgt einen Geburtstag ein: als Parameter werden der Monat und der Tag und ein String erwartet. 
     */
    public void eintragen(int monat, int tag, String name)
    { 
        monat--;
        tag--;
        if(gebTag[monat][tag] == null || gebTag[monat][tag].isEmpty())
        {
            gebTag[monat][tag] = name;
        }
        else 
        {
            gebTag[monat][tag] = gebTag[monat][tag] + " und " + name;
        }  
    }
    
    /**
     * gibt die eingetragenen Geburtstage aus
     */
    public void ausgeben()
    {
        String termine = new String(); 
        String monat = new String();
        
        for(int j = 0; j < gebTag.length; j++)
        {
            switch(j)
            {
                case 0:     monat = "Januar"; 
                            break; 
                case 1:     monat = "Februar"; 
                            break;    
                case 2:     monat = "Mrz"; 
                            break;  
                case 3:     monat = "April"; 
                            break;   
                case 4:     monat = "Mai"; 
                            break;    
                case 5:     monat = "Juni"; 
                            break;   
                case 6:     monat = "Juli"; 
                            break;   
                case 7:     monat = "August"; 
                            break;   
                case 8:     monat = "September"; 
                            break;   
                case 9:     monat = "Oktober"; 
                            break;   
                case 10:    monat = "November"; 
                            break;    
                case 11:    monat = "Dezember"; 
                            break;              
            }
            
            termine = "Geburtstag in diesem Jahr: \n"; 
            
            for(int i = 0; i < gebTag[j].length; i++)
            {
                if(!(gebTag[j][i] == null || gebTag[j][i].isEmpty()))
                {
                    termine = termine + "\tam " + (i + 1) + ". " + monat + ": " + gebTag[j][i] + "\n"; 
                }
            }
            
            termine = termine + "\n";
        }
        
        System.out.println(termine); 
    }
    
    /**
     * initialisiert alle Tage eines Monats
     */
    private void initialisieren()
    {
        for(int i = 0; i < 12; i++)
        {
            switch(i)
            {
                // Monate mit 31 Tagen
                case 0:
                case 2: 
                case 4: 
                case 6: 
                case 7: 
                case 9: 
                case 11:    gebTag[i] = new String[31];
                            break; 
                // Monate mit 30 Tagen:
                case 3: 
                case 5: 
                case 8: 
                case 10:    gebTag[i] = new String[30];
                            break;
                default:    gebTag[i] = new String[29];
                            break;                
            }
        }
                
    }    
    
}
