/**
 * Die Klasse Angestellter modelliert einen Mitarbeiter, der kein Professor ist. 
 * 
 * @author      Florian
 * @version     Kapitel 9
 */
public class Angestellter extends Mitarbeiter
{
    /**
     * Speichert, ob der Angestellte Mitglied des Personalrates ist
     */
    private boolean personalrat; 

    /**
     * Legt fest, ob der Angestellte dem Personalrat angehrt
     * @param personalrat Wahrheitswert, der die Zugehrigkeit bestimmt
     */
    public void setPersonalrat(boolean personalrat)
    {
        this.personalrat = personalrat;
    }

    /**
     * Gibt zurck, ob der Angestellte Mitglied im Personalrat ist
     * @return true, wenn Personalrat, sonst false
     */
    public boolean isPersonalrat()
    {
        return personalrat; 
    }

    /**
     * Gibt einen String zurck, der einen Vorstellungstext enthlt
     * @return Zeichenkette mit einer kurzen Vorstellung
     */
    public String vorstellen()
    {
        String rueckgabe = "Guten Tag, ich heie " + getName() + ". "; 
        rueckgabe += "Meine Personalnummer ist " + getPersonalnummer();
        if(isPersonalrat())
            rueckgabe += " und ich bin Personalratsmitglied. ";
        else 
            rueckgabe += " und ich bin kein Personalratsmitglied.";
        return rueckgabe; 
    }
}
