
/**
 * Die Klasse ist die Superklasse fr alle Action-Klassen. 
 * 
 * @author      Florian 
 * @version     Kapitel 10
 */
public abstract class AbstractAction
{
    /**
     * Angabe, wie viele Monate der Gaukler ben musste
     */
    private final int DAUER; 

    /**
     * Erwartet als Parameter die Anzahl Monate, die der Gaukler ben musste
     */
    protected AbstractAction(int dauer)
    {
        this.DAUER = dauer; 
    }

    /**
     * Gibt die Dauer zurck
     * @return Zeichenkette, die die Dauer zurckgibt
     */
    public String getDauer()
    {
        return "Ich musste " + DAUER + " Monate ben, bis das Kunststck geklappt hat.";
    }
    
    /**
     * Gibt eine Beschreibung der gerade abgeschlossenen Aktion ab
     */
    protected abstract String getBeschreibung();
}
