
/**
 * Die Klasse modelliert einen Marktbesucher. Sie wird nur bergangsweise bentigt. 
 */

public class Marktbesucher implements Zuschauer
{ 
    /**
     * Der Name des Zuschauers
     */
    private String name; 

    /**
     * Nimmt den Namen des Marktbesuchers entgegen 
     * @param name Der Name des Besuchers
     */
    public Marktbesucher(String name)
    {
        this.name = name; 
    }

    /**
     * Definiert das Verhalten von Marktbesuchern
     * @param aktion Die gerade beendete Aktion 
     */
    public void update(Object aktion)
    {
        AbstractAction temp = (AbstractAction) aktion;
        System.out.println("\n" + name + " wird informiert: " + temp);

        System.out.println("Der Gaukler erzhlt: \"" + temp.getDauer() + "\"");

        int zufallszahl = ((int) (Math.random() * 10));
        if(temp.getClass() == FeuerspuckenAction.class)
        {
            if( zufallszahl >= 5 )
                System.out.println(name + " tritt einen Schritt zurck.");
            else
                System.out.println(name + " holt einen Feuerlscher.");
        }
        else 
        {
            zufallszahl = ((int) (Math.random() * 10));
            if(zufallszahl < 5)
                System.out.println("Der Gaukler zeigt " + name + ": \"" + temp.getBeschreibung() + "\"");
            else
                System.out.println(name + " macht ein Foto");
        }
    }

    @Override
    public String toString()
    {
        return name;
    }
}