
/**
 * Oberfläche des Programms
 * 
 * @author      Florian 
 * @version     Kapitel 12
 */
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.JFrame;
import javax.swing.WindowConstants;
import javax.swing.JTabbedPane;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

public class GUI extends JFrame implements WindowListener
{    
    public GUI()
    {
        // eine TabbedPane anlegen
        JTabbedPane tbbMain = new JTabbedPane();        
        // einige Reiter anlegen
        tbbMain.add(new KatzenPanel(), "Katze");
        tbbMain.add(createCatPanel(), "Katzenbild (gross)");
        tbbMain.add(new PasswordPanel(), "Passwort-Eingabe");
        tbbMain.add(new JPanel(), "Panel Nr. 4");
        tbbMain.add(new JPanel(), "Panel Nr. 5");

        // TabbedPane auf Oberfläche legen
        this.add(tbbMain);
        // optimale Größe bestimmen
        this.setSize(700, 600);
        // Titel für das Fenster
        this.setTitle("Lösungsvorschlag Kapitel 12");
        // sichtbar machen
        this.setVisible(true);    
        // diese Funktion muss jetzt geändert werden
        // this.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        this.addWindowListener(this);
    }

    private JScrollPane createCatPanel()
    {
        // ein Grafik-Objekt erzeugen
        ImageIcon icnKatze = new ImageIcon("Cat_04.jpg");
        // ein Label für die Anzeige 
        JLabel lblAnzeige = new JLabel(icnKatze);    
        // ScrollPane anlegen
        JScrollPane scrAnzeige = new JScrollPane(lblAnzeige);
        return scrAnzeige;
    }

    public void windowOpened(WindowEvent e)
    {
        // do nothing
    }

    public void windowClosing(WindowEvent e)
    { 
        String titel = this.getTitle();
        this.setTitle("Das Programm soll beendet werden.");
        int result = JOptionPane.showConfirmDialog(this, "Das Programm wird jetzt beendet", "Hinweis", JOptionPane.YES_NO_OPTION);
        if(result == JOptionPane.YES_OPTION)
            System.exit(0);
        else 
            this.setTitle(titel);
    }

    public void windowClosed(WindowEvent e)
    {
        // do nothing
    }

    public void windowIconified(WindowEvent e)
    {
        // do nothing
    }

    public void windowDeiconified(WindowEvent e)
    {
        // do nothing
    }

    public void windowActivated(WindowEvent e)
    {
        // do nothing
    }

    public void windowDeactivated(WindowEvent e)
    {
        // do nothing
    }
}
