/**
 * Startklasse und Controller fr das Programm
 * 
 * @author      Florian 
 * @version     Kapitel 13
 */
import java.awt.event.*;
import javax.swing.JRadioButton;

public class ApplStart implements ActionListener
{
    private final Planetenverwaltung model;
    private GUI view;
    private ItemListener nameIL = new ItemListener()
        {
            public void itemStateChanged(ItemEvent ev)
            {
                JRadioButton temp = (JRadioButton) ev.getSource();
                if(temp.isSelected())
                {
                    model.setSort(new NameComparator());
                    model.fireTableDataChanged();
                }
            }
        };
    private ItemListener zeitIL = new ItemListener()
        {
            public void itemStateChanged(ItemEvent ev)
            {
                JRadioButton temp = (JRadioButton) ev.getSource();
                if(temp.isSelected())
                {
                    model.setSort(new ZeitComparator());
                    model.fireTableDataChanged();
                }
            }
        };

    public ApplStart(GUI view, Planetenverwaltung model)
    {
        view.tblInfos.setModel(model);   
        view.btnLoeschen.addActionListener(this);

        // Listner fr die RadioButtons als anonyme Klassen
        view.rdbSortName.addItemListener(nameIL); 
        view.rdbSortZeit.addItemListener(zeitIL); 

        this.view = view;
        this.model = model;

        // Renderer implementieren
        Planetenverwaltung.MyPlanetRenderer renderer = new Planetenverwaltung.MyPlanetRenderer();
        this.view.tblInfos.setDefaultRenderer(Boolean.class, renderer);

    }

    public static void main(String[] args)
    {
        new ApplStart(new GUI(), new Planetenverwaltung());
    }

    public void actionPerformed(ActionEvent ev)
    {
        model.loeschePluto();
        view.btnLoeschen.setEnabled(false);
        model.fireTableDataChanged();
        // wird aus didaktischen Grnden gendert: model.fireTableRowsDeleted(8, 8);
    }
} 
