
/**
 * Demonstriert die Verwendung zweier Threads
 * 
 * @author      Florian 
 * @version     Lösung für Kapitel 16
 */
public class Threads
{
    private static class MyRunnable implements Runnable
    {
        public void run()
        {
            for(char zeichen = 'a'; zeichen <= 'z'; zeichen++)
            {
                try
                {
                    Thread.sleep(1000);
                }
                catch(Exception ex)
                {
                    System.out.println(ex.getMessage());
                }
                System.out.println(zeichen);
            }
        }
    }

    private static class MyThread extends Thread
    {
        public void run()
        {
            for(char zeichen = 'z'; zeichen >= 'a'; zeichen--)
            {
                try
                {
                    Thread.sleep(1000);
                }
                catch(Exception ex)
                {
                    System.out.println("\t" + ex.getMessage());
                }
                System.out.println("\t" + zeichen);
            }
        }
    }

    public static void main(String[] args)
    {
        MyRunnable myRunnable = new MyRunnable();
        Thread runnableDemo = new Thread(myRunnable);
        runnableDemo.start();

        Thread thread = new MyThread();
        thread.start();
    }
}
