
/**
 * Die Klasse beschreibt einen Studenten mit Namen und Matrikelnummer
 * 
 * @author      Florian
 * @version     Kapitel 8
 */
public class Student
{
    /**
     * Name des Studenten
     */
    private String name = new String(); 
    /**
     * Matrikelnummer des Studenten
     */
    private int matrikel = 0; 
    /**
     * Der Student schreibt vier Klausuren pro Semester
     */
    private Klausur[] klausuren = new Klausur[4];
    
    /**
     * Legt den Namen des Studenten fest
     * @param name Der Name des Studenten
     */
    public void setName(String name)
    {
        this.name = name; 
    }
    
    /**
     * Gibt den Namen des Studenten zurck 
     * @return Name des Studenten 
     */
    public String getName()
    {
        return name; 
    }
    
    /**
     * Definiert die Matrikelnummer des Studenten 
     * @param matrikel Die Matrikelnummer des Studenten 
     */
    public void setMatrikel(int matrikel)
    {
        this.matrikel = matrikel;
    }
    
    /**
     * Gibt die Matrikelnummer des Studenten
     * @return Matrikelnummer des Studenten 
     */    
    public int getMatrikel()
    {
        return matrikel; 
    }
    
    /**
     * Erzeugt ein neues Objekt dre Klasse Klausur 
     * @param index Die Nummer der angeforderten Klausur im Array
     */
    public void setKlausur(int index)
    {
        klausuren[index] = new Klausur();
    }
    
    /**
     * Gibt eine String-Reprsentation der bezeichneten Klausur zurck
     * @param index Die Nummer der angeforderten Klausur im Array
     * @return Beschreibung der Klausur
     */
    public String getKlausur(int index)
    {
        return klausuren[index].toString();
        /**
         * Im Hinblick auf das nchste Kapitel soll gesagt sein, dass auch mglich ist. 
         * return klausur[i];
         * 
         * Begrndung: 
         * Die Methode toString() hat fr Java eine besondere Bedeutung - immer wenn eine String-
         * Reprsentation angefordert wird, wird die Methode toString() aufgerufen, selbst wenn 
         * diese Methodenaufruf entfllt. 
         */
    }
}
