
/**
 * Die Klasse beschreibt einen Studenten mit Namen und Matrikelnummer
 * 
 * @author      Florian
 * @version     Kapitel 8
 */
public class Student
{
    /**
     * Name des Studenten
     */
    private String name = new String(); 
    /**
     * Matrikelnummer des Studenten
     */
    private int matrikel = 0; 
    /**
     * Der Student schreibt vier Klausuren pro Semester
     */
    private Klausur[] klausuren = new Klausur[4];
    /**
     * Fachrichtung, die der Student studiert
     */
    private Fachrichtung fach;
    
    /**
     * Parameterloser Standardkonstruktor<br>
     * Der Parameter muss angelegt werden, weil er von Java nicht mehr automatisch angelegt wird, wenn 
     * ein Parameter - unabhngig von der Parameterzahl - angelegt wird. 
     */
    public Student()
    {
        
    }
    
    /**
     * Konstruktor, der den Namen als Parameter erwartet
     * @param name Name des Studenten 
     */
    public Student(String name)
    {
        this.name = name;
    }
        
    /**
     * Konstruktor, der den Namen und die Matrikelnummer des Studenten erwartet
     * @param name Name des Studenten
     * @param matrikel Matrikelnummer des Studenten 
     */
    public Student(String name, int matrikel)
    {
        this(name);
        this.matrikel = matrikel; 
    }
    
    /**
     * Der Student stellt sich vor 
     */
    public void vorstellen()
    {
        System.out.println("Guten Tag, ich heie " + name + " und studiere \"" + fach +"\".");
        System.out.println("Ich habe folgende Klausuren geschrieben: ");
        for(int i = 0; i < klausuren.length; i++)
        {
            System.out.println(klausuren[i]);
        }
        System.out.println("\n");
    }
    
    /**
     * Legt die Fachrichtung fest, die der Student studiert
     * @param fach Die Fachrichtung des Studenten
     */
    public void setFachrichtung(Fachrichtung fachrichtung)
    {
        fach = fachrichtung; 
    }
    
    /**
     * Legt den Namen des Studenten fest
     * @param name Der Name des Studenten
     */
    public void setName(String name)
    {
        this.name = name; 
    }
    
    /**
     * Gibt den Namen des Studenten zurck 
     * @return Name des Studenten 
     */
    public String getName()
    {
        return name; 
    }
    
    /**
     * Definiert die Matrikelnummer des Studenten 
     * @param matrikel Die Matrikelnummer des Studenten 
     */
    public void setMatrikel(int matrikel)
    {
        this.matrikel = matrikel;
    }
    
    /**
     * Gibt die Matrikelnummer des Studenten
     * @return Matrikelnummer des Studenten 
     */    
    public int getMatrikel()
    {
        return matrikel; 
    }
    
    /**
     * Erzeugt ein neues Objekt dre Klasse Klausur 
     * @param index Die Nummer der angeforderten Klausur im Array
     * @param thema Das Thema der Klausur
     * @param punkte Die erreichte Punktzahl
     */
    public void setKlausur(int index, String thema, int punkte)
    {
        klausuren[index] = new Klausur(thema, punkte);
    }
    
    /**
     * Gibt eine String-Reprsentation der bezeichneten Klausur zurck
     * @param index Die Nummer der angeforderten Klausur im Array
     * @return Beschreibung der Klausur
     */
    public String getKlausur(int index)
    {
        return klausuren[index].toString();
        /**
         * Im Hinblick auf das nchste Kapitel soll gesagt sein, dass auch folgendes mglich ist:
         * return klausur[i];
         * 
         * Begrndung: 
         * Die Methode toString() hat fr Java eine besondere Bedeutung - immer wenn eine String-
         * Reprsentation angefordert wird, wird automatisch die Methode toString() aufgerufen
         */
    }
}
